// -*- C++ -*-
/*!
 * @file  ConsoleIn.cpp
 * @brief Console input component
 * $Date: 2008/04/18 06:54:51 $
 *
 * $Id: ConsoleIn.cpp,v 1.1 2008/04/18 06:54:51 yoshi Exp $
 */

#include "ConsoleIn.h"
#include <iostream>

// Module specification
// <rtc-template block="module_spec">
static const char* consolein_spec[] =
  {
    "implementation_id", "StringIn",
    "type_name",         "StringIn",
    "description",       "String input component",
    "version",           "1.0",
    "vendor",            "Noriaki Ando, AIST",
    "category",          "example",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

StringIn::StringIn(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_outOut("out", m_out),
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  registerOutPort("out", m_outOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

StringIn::~StringIn()
{
}


RTC::ReturnCode_t StringIn::onExecute(RTC::UniqueId ec_id)
{
  std::string s;
  std::cout << "Please input string: ";
  std::getline(std::cin,s);
  m_out.data = CORBA::string_dup(s.c_str());
  m_outOut.write();

  return RTC::RTC_OK;
}


extern "C"
{
 
  void StringInInit(RTC::Manager* manager)
  {
    RTC::Properties profile(consolein_spec);
    manager->registerFactory(profile,
                             RTC::Create<StringIn>,
                             RTC::Delete<StringIn>);
  }
  
};


