// -*- C++ -*-
/*!
 * @file  HelloRTWorld.cpp
 * @brief HelloRTWorld component
 * $Date: 2007-10-09 07:33:08 $
 *
 * $Id: HelloRTWorld.cpp 775 2008-07-28 16:14:45Z n-ando $
 */

#include "HelloRTWorld.h"
#include <coil/Time.h>

// Module specification
// <rtc-template block="module_spec">
static const char* hellortworld_spec[] =
  {
    "implementation_id", "HelloRTWorld",
    "type_name",         "HelloRTWorld",
    "description",       "Hello RT world component",
    "version",           "1.0",
    "vendor",            "Noriaki Ando, AIST",
    "category",          "example",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

HelloRTWorld::HelloRTWorld(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

HelloRTWorld::~HelloRTWorld()
{
}


RTC::ReturnCode_t HelloRTWorld::onInitialize()
{
  return RTC::RTC_OK;
}

RTC::ReturnCode_t HelloRTWorld::onExecute(RTC::UniqueId ec_id)
{
  RTM_MESSAGE_OUT1("Hello RT World!!!\n" );
  return RTC::RTC_OK;
}


extern "C"
{
 
  void HelloRTWorldInit(RTC::Manager* manager)
  {
    RTC::Properties profile(hellortworld_spec);
    manager->registerFactory(profile,
                             RTC::Create<HelloRTWorld>,
                             RTC::Delete<HelloRTWorld>);
  }
  
};
