// -*- C++ -*-
/*!
 * @file  HelloWorld.cpp
 * @brief HellowWorld Task
 * @date  $Date: 2005-05-12 09:06:20 $
 *
 * $Id: HelloWorld.cpp 775 2008-07-28 16:14:45Z n-ando $
 */


#include <itron.h>
#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include <coil/Task.h>
#include <coil/Time.h>
#include <rtm/Manager.h>
#include <rtm/Timer.h>
#include "tinet_id.h"
#include <netinet/in.h>
#include <netinet/in_itron.h>
#include "HelloWorld.h"


/*
 *  ѿ
 */

/*  TCP ɥХåե  */

UB tcp_swbuf1[TCP_SWBUF_SIZE];
UB tcp_rwbuf1[TCP_RWBUF_SIZE];

UB tcp_swbuf2[TCP_SWBUF_SIZE];
UB tcp_rwbuf2[TCP_RWBUF_SIZE];

UB tcp_swbuf3[TCP_SWBUF_SIZE];
UB tcp_rwbuf3[TCP_RWBUF_SIZE];

UB tcp_swbuf4[TCP_SWBUF_SIZE];
UB tcp_rwbuf4[TCP_RWBUF_SIZE];

UB tcp_swbuf5[TCP_SWBUF_SIZE];
UB tcp_rwbuf5[TCP_RWBUF_SIZE];


class HelloWorldTask : coil::Task
{
public:
  HelloWorldTask( ID tsk ) : coil::Task( tsk ){}

  int svc()
  {
    // TInetWrapperν
    initTIW( 0 );

#ifdef ORB_NAME_SERVER_ENABLE
    // NameServerεư
    act_tsk( ORB_NAME_TASK );

    // NameServerưޤԵ
    wai_sem( RTM_WAIT_NAMESERVER_SEM );
#endif // ORB_NAME_SERVER_ENABLE


#ifdef RTM_HRW_ENABLE
    // HelloRTWorldεư
    act_tsk( RTM_HRW_MAIN_TASK );

    // HelloRTWorldưޤԵ
    wai_sem( RTM_WAIT_HRW_SEM );
#endif // RTM_HRW_ENABLE


#ifdef RTM_ACTIVATOR_ENABLE
    // Activatorεư
    act_tsk( RTM_ACT_MAIN_TASK );
#endif // RTM_ACTIVATOR_ENABLE

    ext_tsk();
    return 0;
  }
};

/*!
 * @if jp
 * @brief HelloWorldᥤ󥿥
 * @else
 * @endif
 */
HelloWorldTask tsk( HELLO_WORLD_TASK );

void hello_world_main_task(intptr_t exinf)
{
  coil::Task::svc_run((void*)&tsk);
}

/*!
 * @if jp
 * @brief ˥󥰥
 * @else
 * @endif
 */
RTC::Manager::OrbRunner RunnerTask( RTM_RUNNING_TASK );

void rtm_running_task(intptr_t exinf)
{
  coil::Task::svc_run((void*)&RunnerTask);
}

/*!
 * @if jp
 * @brief ޥ
 * @else
 * @endif
 */
RTC::Timer TimerTask( RTM_TIMER_TASK, RTM_TIMER_SEM );

void rtm_timer_task(intptr_t exinf)
{
  coil::Task::svc_run((void*)&TimerTask);
}
