// -*- C++ -*-
/*!
 * @file  LEDandSW.cpp
 * @brief LEDandSW Task
 * $Date: 2008-12-15 00:00:00 $
 *
 * $Id: LEDandSW.cpp 775 2008-07-28 16:14:45Z n-ando $
 */

#include <itron.h>
#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include <coil/Task.h>
#include <coil/Time.h>
#include <rtm/Manager.h>
#include <rtm/Timer.h>
#include "tinet_id.h"
#include <netinet/in.h>
#include <netinet/in_itron.h>
#include "LEDandSW.h"

/*
 *  ѿ
 */

/*  TCP ɥХåե  */

UB tcp_swbuf1[TCP_SWBUF_SIZE];
UB tcp_rwbuf1[TCP_RWBUF_SIZE];

UB tcp_swbuf2[TCP_SWBUF_SIZE];
UB tcp_rwbuf2[TCP_RWBUF_SIZE];

UB tcp_swbuf3[TCP_SWBUF_SIZE];
UB tcp_rwbuf3[TCP_RWBUF_SIZE];

UB tcp_swbuf4[TCP_SWBUF_SIZE];
UB tcp_rwbuf4[TCP_RWBUF_SIZE];

UB tcp_swbuf5[TCP_SWBUF_SIZE];
UB tcp_rwbuf5[TCP_RWBUF_SIZE];

UB tcp_swbuf6[TCP_SWBUF_SIZE];
UB tcp_rwbuf6[TCP_RWBUF_SIZE];

UB tcp_swbuf7[TCP_SWBUF_SIZE];
UB tcp_rwbuf7[TCP_RWBUF_SIZE];

UB tcp_swbuf8[TCP_SWBUF_SIZE];
UB tcp_rwbuf8[TCP_RWBUF_SIZE];

UB tcp_swbuf9[TCP_SWBUF_SIZE];
UB tcp_rwbuf9[TCP_RWBUF_SIZE];

class LEDandSWTask : coil::Task
{
public:
  LEDandSWTask( ID tsk ) : coil::Task( tsk ){}

  int svc()
  {
    // TInetWrapperν
    initTIW( 0 );


#ifdef ORB_NAME_SERVER_ENABLE
    // NameServerεư
    act_tsk( ORB_NAME_TASK );

    // NameServerưޤԵ
    wai_sem( RTM_WAIT_NAMESERVER_SEM );
#endif // ORB_NAME_SERVER_ENABLE


#ifdef RTM_LEDOUT_ENABLE
    // LEDOutεư
    act_tsk( RTM_LEDOUT_MAIN_TASK );

    // LEDOutưޤԵ
    wai_sem( RTM_WAIT_LEDOUT_SEM );
#endif // RTM_LEDOUT_ENABLE


#ifdef RTM_SWIN_ENABLE
    // ConsoleInεư
    act_tsk( RTM_SWIN_MAIN_TASK );

    // ConsoleInưޤԵ
    wai_sem( RTM_WAIT_SWIN_SEM );
#endif // RTM_SWIN_ENABLE


#ifdef RTM_CONNECTOR_ENABLE
    // Connectorεư
    act_tsk( RTM_CON_MAIN_TASK );
#endif // RTM_CONNECTOR_ENABLE

    ext_tsk();
    return 0;
  }
};

/*!
 * @if jp
 * @brief LEDandSWᥤ󥿥
 * @else
 * @endif
 */
LEDandSWTask tsk( LEDANDSW_TASK );

void ledandsw_main_task(intptr_t exinf)
{
  coil::Task::svc_run((void*)&tsk);
}

/*!
 * @if jp
 * @brief ˥󥰥
 * @else
 * @endif
 */
RTC::Manager::OrbRunner RunnerTask( RTM_RUNNING_TASK );

void rtm_running_task(intptr_t exinf)
{
  coil::Task::svc_run((void*)&RunnerTask);
}

/*!
 * @if jp
 * @brief ޥ
 * @else
 * @endif
 */
RTC::Timer TimerTask( RTM_TIMER_TASK, RTM_TIMER_SEM );

void rtm_timer_task(intptr_t exinf)
{
  coil::Task::svc_run((void*)&TimerTask);
}
