// -*- C++ -*-
/*!
 * @file  SdoConfigurationInfo.cpp
 * @brief Sdo Configuration Semaphore Info
 * @date  $Date: 2005-05-12 09:06:20 $
 *
 * $Id: SdoConfigurationInfo.cpp 775 2008-07-28 16:14:45Z n-ando $
 */

#include <itron.h>
#include <kernel_cfg.h>
#include <SdoConfigurationInfo.h>
#include <rtm/RTMUtil.h>

static int s_courrent_index = 0;

static S_SDO_CONFIGURATION_SEM s_sdo_configuration_sem[] = {

  { RTM_SDO_DP_SEM1, RTM_SDO_SP_SEM1, RTM_SDO_PL_SEM1, RTM_SDO_CL_SEM1, RTM_SDO_OL_SEM1 },
  { RTM_SDO_DP_SEM2, RTM_SDO_SP_SEM2, RTM_SDO_PL_SEM2, RTM_SDO_CL_SEM2, RTM_SDO_OL_SEM2 },

  /* Configuration_implNX(SdoConfiguration.cpp)gpꍇ͏LɃ\[XLq邱 */
  { 0, 0, 0, 0, 0 }
};

/*!
 * @if jp
 * @brief SdoConfigurationpZ}tH̎擾
 * @else
 * @brief Get Semaphore Info for SdoConfiguration
 * @endif
 */
S_SDO_CONFIGURATION_SEM* getSDOConfigurationSem( void )
{
  S_SDO_CONFIGURATION_SEM* result = NULL;
  RTM_CRITICAL_SECTION_START
  if ( s_sdo_configuration_sem[ s_courrent_index ].dprofile_sem_id > 0 )
  {
    result = &(s_sdo_configuration_sem[ s_courrent_index ]);
    s_courrent_index++;
  }
  RTM_CRITICAL_SECTION_END

  if ( result == NULL )
  {
    RTM_ERROR_OUT1( "getSDOConfigurationSem Error" );
  }
  return result;
}
