// -*- C++ -*-
/*!
 * @file  StringOut.cpp
 * @brief String output component
 * $Date: 2007-10-09 07:33:08 $
 *
 * $Id: StringOut.cpp 775 2008-07-28 16:14:45Z n-ando $
 */

#include "StringOut.h"
#include <coil/Time.h>

// Module specification
// <rtc-template block="module_spec">
static const char* stringout_spec[] =
  {
    "implementation_id", "StringOut",
    "type_name",         "StringOut",
    "description",       "String output component",
    "version",           "1.0",
    "vendor",            "Noriaki Ando, AIST",
    "category",          "example",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

StringOut::StringOut(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_string_inIn("string_in", m_string_in),
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

StringOut::~StringOut()
{
}


RTC::ReturnCode_t StringOut::onInitialize()
{
  registerInPort("string_in",m_string_inIn);
  return RTC::RTC_OK;
}

RTC::ReturnCode_t StringOut::onExecute(RTC::UniqueId ec_id)
{


  if (m_string_inIn.isNew())
    {
      m_string_inIn.read();
      RTM_MESSAGE_OUT2("Received: %s\n",m_string_in.data);
    }

  return RTC::RTC_OK;
}


extern "C"
{
 
  void StringOutInit(RTC::Manager* manager)
  {
    RTC::Properties profile(stringout_spec);
    manager->registerFactory(profile,
                             RTC::Create<StringOut>,
                             RTC::Delete<StringOut>);
  }
  
};
