/*
 * 
 * OpenRTM[eBeBwb_
 * RTMUtil.h
 */

#ifndef __RTMUTIL_H__
#define __RTMUTIL_H__

#ifdef __cplusplus
extern "C" {
#endif	// __cplusplus

#include <itron.h>
#include <kernel.h>
#include <t_syslog.h>
#include "kernel_cfg.h"

#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "stringlib.h"

#include <rtm/RTMDefine.h>

/* bZ[Wo̓}N */
#define	RTM_MESSAGE_OUT1( msg )				wai_sem( RTM_LOG_SEM ); \
							t_printf_0( msg ); \
							sig_sem( RTM_LOG_SEM )

#define	RTM_MESSAGE_OUT2( msg, param1 )			wai_sem( RTM_LOG_SEM ); \
							t_printf_1( msg, (int)param1 ); \
							sig_sem( RTM_LOG_SEM )

#define	RTM_MESSAGE_OUT3( msg, param1, param2 )		wai_sem( RTM_LOG_SEM ); \
							t_printf_2( msg, (int)param1, (int)param2 ); \
							sig_sem( RTM_LOG_SEM )

#define	RTM_MESSAGE_OUT4( msg, param1, param2, param3)	wai_sem( RTM_LOG_SEM ); \
							t_printf_3( msg, (int)param1, (int)param2, (int)param3 ); \
							sig_sem( RTM_LOG_SEM )

/* G[o̓}N */
#define	RTM_ERROR_OUT1( msg )				wai_sem( RTM_LOG_SEM ); \
							syslog( RTM_ERROR_MESSAGE, msg ); \
							sig_sem( RTM_LOG_SEM )

#define	RTM_ERROR_OUT2( msg, param1 )			wai_sem( RTM_LOG_SEM ); \
							syslog( RTM_ERROR_MESSAGE, msg, param1 ); \
							sig_sem( RTM_LOG_SEM )

#define	RTM_ERROR_OUT3( msg, param1, param2 )		wai_sem( RTM_LOG_SEM ); \
							syslog( RTM_ERROR_MESSAGE, msg, param1, param2 ); \
							sig_sem( RTM_LOG_SEM )

#define	RTM_ERROR_OUT4( msg, param1, param2, param3)	wai_sem( RTM_LOG_SEM ); \
							syslog( RTM_ERROR_MESSAGE, msg, param1, param2, param3 ); \
							sig_sem( RTM_LOG_SEM )

/* rp}N */
#define	RTM_CRITICAL_SECTION_START	loc_cpu();
#define	RTM_CRITICAL_SECTION_END	unl_cpu();

#ifdef __cplusplus
}
#endif	// __cplusplus

#endif	// __RTMUTIL_H__
