/*
 * Copyright (c) 2008, AIST.
 * All rights reserved. This program is made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * Contributors:
 * National Institute of Advanced Industrial Science and Technology (AIST)
 */
/*
 *  Simple CORBA Server
 *
 *  Copyright(C) 2006, Isao Hara.AIST
 *
 *  $Revision: 1.3 $
 *  $Date: 2008/05/29 04:54:57 $
 *  $Id: NameService.c,v 1.3 2008/05/29 04:54:57 yoshi Exp $
*/
#include <stdio.h>
#include <signal.h>
#include <pthread.h>
#include <RtORB/corba.h>
#include "CosNaming.h"
#include "kernel_cfg.h"
#include <OpenRTMSetup.h>

#define	ORB_DEFAULT_NAME_PORT	"30001"

extern CORBA_CosNaming_NamingContext
impl_CosNaming_NamingContext__create(PortableServer_POA, CORBA_Environment *);

static CORBA_ORB orb = NULL;

static void quit(int arg)
{
  CORBA_Environment ev;
  if (orb) {
	ORB_MESSAGE_OUT1("Destroying ORB...\n");
    CORBA_ORB_shutdown(orb, 1, &ev);
    CORBA_ORB_destroy(orb, &ev);
    orb = NULL;
	ORB_MESSAGE_OUT1("done\n");
  }
  exit(0);
}

/*!
 * @if jp
 * @brief NameServer^XN
 * @else
 * @endif
 */
void orb_name_task(intptr_t exinf)
{
  CORBA_Environment env;
  char server_addr[64] = "";
  int index;
  int argc = 1;
  char *argv[10];
  argv[0] = "NameServer";

  getNameServerAddr( (int8_t*)server_addr );
  index = 0;
  while( server_addr[index] != '\0' ) {

    if ( server_addr[index] == ':' ) {
      index++;
      break;
    }
    index++;
  }

  argv[argc++] = "-ORBServerPort";
  if ( server_addr[index] >= '0' && server_addr[index] <= '9' ) {
    argv[argc++] = &(server_addr[index]);
  }
  else {
    argv[argc++] = ORB_DEFAULT_NAME_PORT;
  }
//////
  orb = (CORBA_ORB)CORBA_ORB_init(&argc, argv, 0, &env);

  PortableServer_POA poa = (PortableServer_POA)
	  CORBA_ORB_resolve_initial_references(orb,"RootPOA", &env);
  catchDefaultException(&env);

  CosNaming_NamingContext rootContext = (CosNaming_NamingContext)impl_CosNaming_NamingContext__create(poa, &env);
  catchDefaultException(&env);

  ORB_ERROR_OUT2(" %s \n", CORBA_ORB_object_to_string(orb, rootContext, &env));
  PortableServer_POA_reinstall_object(poa, rootContext, "NameService", &env);

////////////////  
  PortableServer_POAManager poa_manager =
         (PortableServer_POAManager)PortableServer_POA__get_the_POAManager(poa, &env);
  PortableServer_POAManager_activate(poa_manager, &env);

/////////////////
  sig_sem( RTM_WAIT_NAMESERVER_SEM );

  CORBA_ORB_run(orb, &env);

  ORB_ERROR_OUT1("Terminate CORBA_ORB_run()\n");
  CORBA_ORB_shutdown(orb, 1, &env);

  exit(1);
}
