/*
 * Copyright (c) 2008, AIST.
 * All rights reserved. This program is made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * Contributors:
 * National Institute of Advanced Industrial Science and Technology (AIST)
 */
/* $Id: server_loop.c,v 1.2 2008/05/29 04:54:56 yoshi Exp $ */
#include <RtORB/corba.h>
#include <sys/time.h>

#ifdef SEC
#undef SEC
#endif
#define SEC(systim) (systim / 1000)

#ifdef USEC
#undef USEC
#endif
#define USEC(systim) ((systim % 1000) * 1000)

void server_loop(float time_out_float, void (*idle)(), void *arg)
{
  struct timeval time_out;
  SYSTIM systim1;
  SYSTIM systim2;

  init_socket_servers();

#ifdef USE_SHMC
  init_shmc_servers();
#endif

  time_out.tv_sec = (unsigned long)(time_out_float / 1000);
  time_out.tv_usec = (time_out_float - time_out.tv_sec * 1000) * 1000 ;
#if DEBUG
  ORB_ERROR_OUT3("timeout = %d, %d\n", (int)time_out.tv_sec, (int)time_out.tv_usec);
#endif

  while (1) {
#if _CYCLIC_TASK
	  get_tim( &systim1 );
#endif

#ifdef USE_SHMC
      select_shmc_servers(time_out);
#else
      select_socket_servers(time_out);
#endif

      if (idle) (*idle)(arg); 
#if _CYCLIC_TASK
     
      get_tim( &systim2 );

      time_cost = ( SEC(systim2) - SEC(systim1) ) * 1000000 + USEC(systim2)
	      - USEC(systim1) - time_out_float * 1000 ;

      if (time_cost > 0) dly_tsk(time_cost);
      
#endif 
  }
}

