// -*- C++ -*-
/*!
 * @file  Guard.h
 * @brief Guard class
 * @date  $Date$
 * @author Noriaki Ando <n-ando@aist.go.jp>
 *
 * Copyright (C) 2008
 *     Noriaki Ando
 *     Task-intelligence Research Group,
 *     Intelligent Systems Research Institute,
 *     National Institute of
 *         Advanced Industrial Science and Technology (AIST), Japan
 *     All rights reserved.
 *
 * $Id$
 *
 */

#ifndef COIL_GUARD_H
#define COIL_GUARD_H

#include <coil/Mutex.h>

namespace coil
{
  class Guard
  {
  public:
    Guard(ID semid) : m_mutex()
    {
      m_mutex.init(semid);
      m_mutex.lock();
    }
    ~Guard()
    {
      m_mutex.unlock();
    }
  private:
    Guard(const Guard&);
    Guard& operator=(const Guard&);
    Mutex m_mutex;
  };
};
#endif // COIL_GUARD_H
