// -*- C++ -*-
/*!
 * @file  Mutex.h
 * @brief RT-Middleware Service interface
 * @date  $Date$
 * @author Noriaki Ando <n-ando@aist.go.jp>
 *
 * Copyright (C) 2008
 *     Noriaki Ando
 *     Task-intelligence Research Group,
 *     Intelligent Systems Research Institute,
 *     National Institute of
 *         Advanced Industrial Science and Technology (AIST), Japan
 *     All rights reserved.
 *
 * $Id$
 *
 */

#ifndef COIL_MUTEX_H
#define COIL_MUTEX_H

#include <kernel.h>
#include <t_syslog.h>

namespace coil
{
  class Mutex
  {
  public:
    Mutex()
    {
    }

    ~Mutex()
    {
    }

    inline void init(ID semid)
    {
      m_semid = semid;
    }

    inline void lock()
    {
      wai_sem(m_semid);
    }

    inline ER trylock()
    {
      return pol_sem(m_semid);
    }

    inline void unlock()
    {
      sig_sem(m_semid);
    }

	ID m_semid;
  private:
    Mutex(const Mutex &);
    Mutex& operator=(const Mutex &);
  };
};
#endif // COIL_MUTEX_H
