// -*- C++ -*-
/*!
 * @file String.cpp
 * @brief String utils
 * @date $Date$
 * @author Noriaki Ando <n-ando@aist.go.jp>
 *
 * Copyright (C) 2008
 *     Task-intelligence Research Group,
 *     Intelligent Systems Research Institute,
 *     National Institute of
 *         Advanced Industrial Science and Technology (AIST), Japan
 *     All rights reserved.
 *
 * $Id$
 *
 */

#include "stringlib.h"

namespace coil
{
    int t_vsnprintf(char *buffer, unsigned long count,
          const char *format, int a1)
    {
       return t_vsnprintf_1(buffer, count, format, a1);
    }

    int t_vsnprintf(char *buffer, unsigned long count,
            const char *format, int a1, int a2)
    {
       return t_vsnprintf_2(buffer, count, format, a1, a2);
    }

    int t_vsnprintf(char *buffer, unsigned long count,
            const char *format, int a1, int a2, int a3)
    {
       return t_vsnprintf_3(buffer, count, format, a1, a2, a3);
    }

    int t_vsnprintf(char *buffer, unsigned long count,
            const char *format, int a1, int a2, int a3, int a4)
    {
       return t_vsnprintf_4(buffer, count, format, a1, a2, a3, a4);
    }

    int t_vsnprintf(char *buffer, unsigned long count,
            const char *format, int a1, int a2, int a3, int a4, int a5)
    {
       return t_vsnprintf_5(buffer, count, format, a1, a2, a3, a4,a5);
    }

    int t_vsnprintf(char *buffer, unsigned long count,
            const char *format, int a1, int a2, int a3, int a4, int a5, int a6)
    {
       return t_vsnprintf_6(buffer, count, format, a1, a2, a3, a4, a5, a6);
    }
}
