// -*- C++ -*-
/*!
 * @file  UUID.cpp
 * @brief RT-Middleware Service interface
 * @date  $Date$
 * @author Noriaki Ando <n-ando@aist.go.jp>
 *
 * Copyright (C) 2008
 *     Noriaki Ando
 *     Task-intelligence Research Group,
 *     Intelligent Systems Research Institute,
 *     National Institute of
 *         Advanced Industrial Science and Technology (AIST), Japan
 *     All rights reserved.
 *
 * $Id$
 *
 */

#include <coil/UUID.h>

namespace coil
{
  UUID_Generator::UUID_Generator(){}

  void UUID_Generator::init(){}

  UUID* UUID_Generator::generateUUID(int varsion, int variant){
    uuid_t uuid;
    coil::uuid_generate(&uuid);
    return new UUID(&uuid);
  }

  UUID::UUID(){
    coil::uuid_clear(&this->_uuid);
  }

  UUID::UUID(uuid_t *uuid){
    this->_uuid.time_low = uuid->time_low;
    this->_uuid.time_mid = uuid->time_mid;
    this->_uuid.clock_seq_low = uuid->clock_seq_low;
    this->_uuid.clock_seq_hi_and_reserved = uuid->clock_seq_hi_and_reserved;
    this->_uuid.time_hi_and_version = uuid->time_hi_and_version;
    memcpy(this->_uuid.node, uuid->node, 6);
  }

  const char* UUID::to_string(){
    coil::uuid_unparse(&this->_uuid, buf);
    return buf;
  }
};
