/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006-2008 by Task-intelligence Research Group,
 *             Intelligent Systems Research Institute,
 *             National Institute of
 *               Advanced Industrial Science and Technology (AIST), Japan
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 * åװ¸Υ֡ȥȥå(EP93XX)
 */
/* System Controller Register */
#define SYSCON_BASE_ASM			0x80930000
#define PWCNT_OFFSET			0x0004
#define CLKSET1_OFFSET			0x0020
#define DEVICECFG_OFFSET		0x0080
#define SYSSWLOCK_OFFSET		0x00C0

/* Static Memory Controller */
#define SMC_BASE_ASM			0x80080000
#define BANK_CFG_1_OFFSET		0x0004
#define BANK_CFG_2_OFFSET		0x0008
#define BANK_CFG_6_OFFSET		0x0018

/* SDRAM, FlashROM Controller Register */
#define SYNCMEM_BASE_ASM		0x80060000
#define GLCONFIG_OFFSET			0x0004
#define REFRSHTIMR_OFFSET		0x0008
#define BOOTSTS_OFFSET			0x000C
#define SDRAMDEVCFG0_OFFSET		0x0010
#define SDRAMDEVCFG1_OFFSET		0x0014
#define SDRAMDEVCFG2_OFFSET		0x0018
#define SDRAMDEVCFG3_OFFSET		0x001C

#define CLK_MODE_MASK			0xC0000000
#define SYNC_CLK_MODE			0x40000000
#define ASYNC_CLK_MODE			0xC0000000


	.section .flash.boot,"ax"
//	.code 32
//	.align 2
	.global _boot_flash
_boot_signature:
	.long  0x53555243			/* CRUS */

_boot_flash:
	/* 
	 * MMUå
	 */
	mov    r0, #0
	mcr    p15, 0, r0, c1, c0, 0
	mcr    p15, 0, r0, c7, c7, 0
	mcr    p15, 0, r0, c8, c7, 0

	/*
	 * SMC
	 */
	ldr    r0, =SMC_BASE_ASM
	ldr    r10, =0x18004D23
	str    r10, [r0, #BANK_CFG_6_OFFSET]
	ldr    r10, =0x000047E3
	str    r10, [r0, #BANK_CFG_1_OFFSET]
	ldr    r10, =0x100047E3
	str    r10, [r0, #BANK_CFG_2_OFFSET]

    /* åPLL1):192MHz FLCK:192MHz HCLK:96MHz PCLK:48MHz */
	/* FCLK DIV:0(1)/nBYP:1/HCLK DIV:1(2)/PCLK DIV:1/PLL1_PS:1(2) */
	/* X1FBD:24/X2FBD2:24/X2IPD:23 */
	ldr    r0, =SYSCON_BASE_ASM
	ldr    r2, =0xAA
	str    r2, [r0, #SYSSWLOCK_OFFSET]
//	ldr    r10, =0x0095C317
//	str    r10, [r0, #CLKSET1_OFFSET]
   /* åPLL1):399.9744MHz FLCK:199.9872MHz HCLK:99.9936MHz PCLK:49.9968MHz */
	ldr    r10, =0x02D0A3D7
	str    r10, [r0, #CLKSET1_OFFSET]
	nop								/* ̿ѥץ饤Υեå */
	nop								/* åɬ */
	nop
	nop
	nop
    /* åPLL2)  ̤ */
	
	/* CPUåΥFCLKƱ */
	mrc    p15, 0, r0, c1, c0, 0
	bic    r0, r0, #CLK_MODE_MASK
	orr    r0, r0, #ASYNC_CLK_MODE
	mcr    p15, 0, r0, c1, c0, 0

	/*
	 * SDRAM(SDCE0)
	 */
	/* 100usԤ */
//	mov    r1, #0x2800	/* 10000 */
	mov    r1, #80	/* 10000 */
_wait1:
	subs   r1, r1, #1
	bne    _wait1
	/* SDRAM */
	ldr    r0, =SYNCMEM_BASE_ASM
	ldr    r10, =0x01210028
	str    r10, [r0, #SDRAMDEVCFG0_OFFSET]
//	/* SDRAMؤΥ */
//	ldr    r10, =0x80000002
//	str    r10, [r0, #GLCONFIG_OFFSET]
//	/* SDRAMΥǥХɹ */
//	/* XXXXX */
	ldr    r10, =0x80000003
	str    r10, [r0, #GLCONFIG_OFFSET]
	/* 200usԤ */
	mov    r1, #0x5000	/* 20000 */
//	mov    r1, #160	/* 20000 */
_wait2:
	subs   r1, r1, #1
	bne    _wait2

	ldr    r10, =0x80000001
	str    r10, [r0, #GLCONFIG_OFFSET]
	ldr    r10, =0x0A
	str    r10, [r0, #REFRSHTIMR_OFFSET]
	/* 80SDCLKԤ */
	mov    r1, #80
_wait3:
	subs   r1, r1, #1
	bne    _wait3

_access_test:
	/* եå奿 */
	ldr    r10, =0x30C			/* 780 XXXXX */
	/* SDRAMΥ⡼ɥ쥸˥ */
	str    r10, [r0, #REFRSHTIMR_OFFSET]
	ldr    r10, =0x80000002
	str    r10, [r0, $GLCONFIG_OFFSET]
	/* SDRAMΥ⡼ɥ쥸 */
	ldr    r4, =0xC0000000
	orr    r4, r4, #0x8800
	ldr    r1, [r4]
	ldr    r10, =0x80000000
	str    r10, [r0, #GLCONFIG_OFFSET]
	/* SDRAMƥ */
	ldr    r4, =0xC0000000
	ldr    r1, [r4]
	orr    r5, r4, #0x400000
	ldr    r1, [r5]
	orr    r5, r4, #0x800000
	ldr    r1, [r5]
	orr    r5, r4, #0xC00000
	ldr    r1, [r5]
	/* Х */
	ldr    r10, =0x00210028
	str    r10, [r0, #SDRAMDEVCFG0_OFFSET]

	/* åPLL1) */
	ldr    r0, =SYSCON_BASE_ASM
	ldr    r2, =0xAA
	str    r2, [r0, #SYSSWLOCK_OFFSET]
	ldr    r10, =0x02A4A3D7
	str    r10, [r0, #CLKSET1_OFFSET]
	nop								/* ̿ѥץ饤Υեå */
	nop								/* åɬ */
	nop
	nop
	nop

	/* ǥХͭ */
	ldr    r0, =SYSCON_BASE_ASM
	ldr    r2, =0xAA
	str    r2, [r0, #SYSSWLOCK_OFFSET]
	ldr    r1, [r0, #PWCNT_OFFSET]
	orr    r1, r1, #0x20000000
	str    r1, [r0, #PWCNT_OFFSET]
	str    r2, [r0, #SYSSWLOCK_OFFSET]
	ldr    r1, [r0, #DEVICECFG_OFFSET]
	orr	   r1, r1, #0x0A000000
	orr	   r1, r1, #0x00140000
	orr	   r1, r1, #0x00000D00
	str    r1, [r0, #DEVICECFG_OFFSET]

	/* ץեå夫SDRAM˥ԡ */
	/* XXXXX */

	/* ץ೫ */
	b      start
