/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006-2008 by Task-intelligence Research Group,
 *             Intelligent Systems Research Institute,
 *             National Institute of
 *               Advanced Industrial Science and Technology (AIST), Japan
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 * åװ¸⥸塼EP93XXѡ
 */

#include "kernel_impl.h"
#include <sil.h>

/*
 * Ƴߤγ׵ػߥե饰ξ
 */
uint32_t idf[2];

/*
 * ߤγͥ٥ޥ
 */
PRI ipm;
 
/*
 *  °ꤵƤ뤫Ƚ̤뤿ѿ
 */
uint32_t	bitpat_cfgint[2];

/*
 * ٥ơ֥ΰ
 */
uint8_t vector_region[MAPPING_SIZE]  __attribute__ ((section (".region.vector")));

/*
 *  åװ¸ν
 */
void
chip_initialize(void)
{
	MEMORY_ATTRIBUTE mattr;
	uint32_t ctrl;
	uint32_t *dst_text,* src_text;
	extern uint32_t  __start_vector_table[];
	extern uint32_t __end_vector_table[];

    /*
     *  ARM¸ν
     */
    core_initialize();

    /*
     *  chip_fput_log ǽˤʤ褦UART
     */
    ep93xx_init_uart();

	/*
	 * MMU
	 */
	ep93xx_mmu_initialize();

    /*
     * Ƴߤγ׵ػߥե饰ػ
     */
    idf[0] = ~0U;
	idf[1] = ~0U;

    /*
     * ͥ٥ޥ0
     */ 
    ipm = 0U;

    /*
     * Ƥγߤޥ
     */ 
	sil_wrw_mem((void*)VIC1_INTENCLEAR, ~0U);
	sil_wrw_mem((void*)VIC2_INTENCLEAR, ~0U);

    /*
     *  °ꤵƤ뤫Ƚ̤뤿ѿ롥
     */
    bitpat_cfgint[0] = 0U;
	bitpat_cfgint[1] = 0U;

    /*
	 * 㳰٥ơ֥Υΰ
	 * 0xFFFF0000˥ޥåԥ󥰤
	 */
	mattr.va = 0xFFF00000;
	mattr.pa = (intptr_t)vector_region;
	mattr.pgsize = PG_SIZE(0x100000);
	mattr.ap = RWRW;
	mattr.cb = WRITE_THROW;
	mattr.dom = 0;
	mmu_map_region(&mattr);

	dst_text = (uint32_t*)0xFFFF0000;
	src_text = (uint32_t*)__start_vector_table;
	for (; (uint32_t)src_text < (uint32_t)(__end_vector_table); src_text++, dst_text++) {
		*dst_text = *src_text;
	}

	/* ٥ơ֥HIGHɥ쥹˻ */
	CP15_READ_CONTROL(ctrl);
	ctrl |= CTRL_VECT_HIGH;
	CP15_WRITE_CONTROL(ctrl);

#ifndef VECTOR_KERNEL
    /*
     *  㳰٥ơ֥سߥϥɥϿ
     *  XXXXX
     */
    x_install_exc(EXCH_NO_IRQ, (FP)interrupt_handler);
    x_install_exc(EXCH_NO_UNDEF, (FP)undef_handler);
    x_install_exc(EXCH_NO_SWI, (FP)swi_handler);
    x_install_exc(EXCH_NO_PABORT, (FP)prefetch_handler);
    x_install_exc(EXCH_NO_DABORT, (FP)data_abort_handler);
    x_install_exc(EXCH_NO_FIQ, (FP)fiq_handler);
#endif /* VECTOR_KERNEL */
}

/*
 *  åװ¸νλ
 */
void
chip_exit(void)
{
    /*
     *  ARM¸νλ
     */
    core_terminate();

    /*
     *  ٤Ƥγߤޥ롥
     */
	sil_wrw_mem((void*)VIC1_INTENCLEAR, ~0U);
	sil_wrw_mem((void*)VIC2_INTENCLEAR, ~0U);

    /*
     *  ȯĶ¸νλ
     */
    ep93xx_exit();
}

/*
 *  åװ¸ʸ
 */
void
chip_fput_log(char_t c)
{
    if (c == '\n') {
        ep93xx_putc('\r');
    }
    ep93xx_putc(c);
}

/*
 *  ׵饤°
 *
 *  ASPͥǤѤꤷơѥ᡼顼ϥǥ
 *  Ƥ롥FI4ͥѤˤϡ顼֤褦ˤ٤
 *  Ǥ
 *
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri)
{
    assert(VALID_INTNO(intno));
    assert(TMIN_INTPRI <= intpri && intpri <= TMAX_INTPRI);

	/*
	 *  °ꤵƤ뤫Ƚ̤뤿ѿ
	 */
	bitpat_cfgint[intno >> 5] |= INTNO_BITPAT(intno & 0x1F);
    
    /* 
     * äߤػߤ
     */    
    x_disable_int(intno);

    if ((intatr & TA_ENAINT) != 0U){
        (void)x_enable_int(intno);
    }
}

/*
 *  (ǥ)ͥ٥ޥ
 * 
 *  ꤵ줿ͥ٤ꤵ줿׵ػߥե饰Υơ֥ͤȡʥ
 *  Ρ˳Ƴߤγ׵ػߥե饰ξ֤ݻѿͤȤ
 *  ORIRCγ׵ػߥե饰˥åȤꤷͥ٤ѿ
 *  ipm¸롥
 */
void
x_set_ipm(PRI intpri)
{
	uint32_t cfgint1, cfgint2;		/* ꤵƤ */
    uint32_t ipm_mask1, ipm_mask2;	/* ̤ͥΥޥ */

	cfgint1 = bitpat_cfgint[0];
	cfgint2 = bitpat_cfgint[1];
    ipm_mask1 = ipm_mask_tbl[INDEX_IPM(intpri)][0];
    ipm_mask2 = ipm_mask_tbl[INDEX_IPM(intpri)][1];

    /*
     *  ߥȥϥ֥͡쥸
     *  ꥢ쥸뤿ᡤöƤγߤػߤƤ顤
     *  γߤΤߵĤɬפ
     */
	sil_wrw_mem((void*)VIC1_INTENCLEAR, ~0U);
	sil_wrw_mem((void*)VIC2_INTENCLEAR, ~0U);

	sil_wrw_mem((void*)VIC1_INTENABLE, cfgint1 & ~(ipm_mask1 | idf[0]));
	sil_wrw_mem((void*)VIC2_INTENABLE, cfgint2 & ~(ipm_mask2 | idf[1]));

    ipm = intpri;
}

#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 * ̤γߤäν
 */
void
default_int_handler(void)
{
    syslog_0(LOG_EMERG, "Unregistered Interrupt occurs.");
    target_exit();
}
#endif /* OMIT_DEFAULT_INT_HANDLER */
