/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006-2008 by Task-intelligence Research Group,
 *             Intelligent Systems Research Institute,
 *             National Institute of
 *               Advanced Industrial Science and Technology (AIST), Japan
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *  åװ¸⥸塼EP93XXѡ
 *
 *  ͥΥåװ¸Υ󥯥롼ɥե롥kernel_impl.hΥ
 *  åȰ¸ΰդȤʤ롥
 */

#ifndef TOPPERS_CHIP_CONFIG_H
#define TOPPERS_CHIP_CONFIG_H

/*
 *  åץƥΥϡɥ񸻤
 */
#include "ep93xx.h"

/*
 *  ٥롼򥫡ͥǻĤ
 */
#define VECTOR_KERNEL

/*
 *  ٥롼ʤΥ٥ɥ쥹Ƭ
 */ 
#define VECTOR_START  0x00

/*
 * Ԥ̿
 */
#define ASM_TARGET_WAIT_INTERRUPT nop

/*
 *  ASPͥưΥޥåפȴϢ
 */
#define RAM_START       SRAM_BASE_ADDRESS
#define RAM_SIZE        SRAM_SIZE

#define FIQ_DATA_SIZE   256U

/*
 *  ǥեȤ󥿥ƥѤΥåΰ
 */
#define DEFAULT_ISTKSZ      0x1000U   /* 4KB */
#define DEFAULT_ISTK        (void *)(RAM_START+RAM_SIZE-FIQ_DATA_SIZE - DEFAULT_ISTKSZ)

                                                   
/*
 *  ԤΤSILΥåȰ¸
 */
#define SIL_DLY_TIM1    420
#define SIL_DLY_TIM2    195

/*
 *  ߥϥɥֹ˴ؤ
 */ 
#define TMIN_INHNO 0U
#define TMAX_INHNO 63U
#define TNUM_INH   64U

/*
 *  ֹ˴ؤ
 */ 
#define TMIN_INTNO 0U
#define TMAX_INTNO 63U
#define TNUM_INT   64U

#ifndef TOPPERS_BOOT_ROM
#define TOPPERS_OMIT_DATA_INIT
#endif /* TOPPERS_BOOT_ROM */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ֹϰϤȽ
 *
 *  ӥåȥѥΤưפˤ뤿ˡ8Ϸ֤ˤʤäƤ롥
 */
#define VALID_INTNO(intno) (TMIN_INTNO <= (intno) && (intno) <= TMAX_INTNO)
#define VALID_INTNO_DISINT(intno)	VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(intno)	VALID_INTNO(intno)
#define VALID_INTNO_ATTISR(intno)   VALID_INTNO(intno)

/*
 *  ߥϥɥϿѥơ֥
 *   ֤ϥե졼 
 */
extern const FP inh_tbl[TNUM_INH];

/*
 *  ߥϥɥ
 */
Inline void
x_define_inh(INHNO inhno, FP int_entry)
{
}

/*
 *  ߥϥɥνޥ
 *
 */
#define INT_ENTRY(inhno, inthdr)    inthdr
#define INTHDR_ENTRY(inhno, inhno_num, inthdr) extern void inthdr(void);

/*
 *  TOPPERSɸ߽ǥμ¸
 */

/*
 * Ƴߤγ׵ػߥե饰ξ
 */
extern uint32_t idf[2];

/*
 *  ͥ٥ޥ饤֥
 *
 *  AT91SAM7Sϳͥ٥ޥIRCǥϡɥŪ˻Ĥ
 *  եȥ¦ͤɤ߽񤭤Ǥʤᡤ׵ػߥե
 *  ˤͥ٥ޥ¸
 */

/*
 *  ߤγͥ٤
 */
extern PRI ipm;

/*
 *  ͥ٥ޥ˥åȤ롤׵ػߥե饰
 *  Υơ֥
 */
extern const uint32_t ipm_mask_tbl[8][2];

#endif /* TOPPERS_MACRO_ONLY */  

/*
 *  IPMipm_mask_tblΥǥåѴޥ
 */
#define INDEX_IPM(ipm)  (-(ipm))

#ifndef TOPPERS_MACRO_ONLY

/*
 *  (ǥ)ͥ٥ޥ
 */
extern void x_set_ipm(PRI intpri);

#define t_set_ipm(intpri) x_set_ipm(intpri)
#define i_set_ipm(intpri) x_set_ipm(intpri)

/*
 *  (ǥ)ͥ٥ޥλ
 *
 *  ipm֤ͤ
 */
Inline PRI
x_get_ipm(void)
{
    return(ipm);
}

#define t_get_ipm() x_get_ipm()
#define i_get_ipm() x_get_ipm()

/*
 *  °ꤵƤ뤫Ƚ̤뤿ѿ
 */
extern uint32_t	bitpat_cfgint[];

/*
 * ʥǥΡ˳׵ػߥե饰Υå
 *
 *  ꤵ줿ֹγ׵ػߥե饰ΥåȤơߤ
 *  ػߤ롥ޤʥǥΡ˳׵ػߥե饰idf
 *  ӥåȤ򥻥åȤ롥
 *  ׵ޥ뵡ǽ򥵥ݡȤƤʤˤϡfalse֤
 */
Inline bool_t
x_disable_int(INTNO intno)
{
	assert(VALID_INTNO(intno));

	if ((bitpat_cfgint[intno >> 5] & INTNO_BITPAT(intno)) == 0x00) {
		return false;
	}
	if (intno < VIC1_INTNUM) {
		sil_wrw_mem((void*)VIC1_INTENCLEAR, INTNO_BITPAT(intno));
		idf[0] |= INTNO_BITPAT(intno);
	} else {
		sil_wrw_mem((void*)VIC2_INTENCLEAR, INTNO_BITPAT(intno - VIC2_INTNO_BASE));
		idf[1] |= INTNO_BITPAT(intno - VIC2_INTNO_BASE);
	}

    return true;
}

#define t_disable_int(intno)  x_disable_int(intno)
#define i_disable_int(intno)  t_disable_int(intno)

/* 
 * (ǥ)׵ػߥե饰β
 *
 * ꤵ줿ֹγ׵ػߥե饰Υꥢơߤ
 * Ĥ롥ޤʥǥΡ˳׵ػߥե饰idf
 * ӥåȤ򥯥ꥢ롥
 * ׵ޥ뵡ǽ򥵥ݡȤƤʤˤϡfalse֤
 */
Inline bool_t
x_enable_int(INTNO intno)
{
	assert(VALID_INTNO(intno));

	if ((bitpat_cfgint[intno >> 5] & INTNO_BITPAT(intno)) == 0x00) {
		return false;
	}
	/* IRQ */
	if (intno < VIC1_INTNUM) {
		sil_wrw_mem((void*)VIC1_INTENABLE, INTNO_BITPAT(intno));
		idf[0] &= ~INTNO_BITPAT(intno);
	} else {
		sil_wrw_mem((void*)VIC2_INTENABLE, INTNO_BITPAT(intno - VIC2_INTNO_BASE));
		idf[1] &= ~INTNO_BITPAT(intno - VIC2_INTNO_BASE);
	}
    return true;
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)

/*
 * ׵Υꥢ
 */
Inline void
x_clear_int(INTNO intno)
{
}

#define t_clear_int(intno) x_clear_int(intno) 
#define i_clear_int(intno) x_clear_int(intno) 


/*
 *  ׵Υå
 */
Inline bool_t
x_probe_int(INTNO intno)
{
	if (intno < VIC1_INTNUM) {
		if (sil_rew_mem((void*)VIC1_INTSELECT) & INTNO_BITPAT(intno)) {
			/* FIQ */
			if (sil_rew_mem((void*)VIC1_FIQSTATUS) & INTNO_BITPAT(intno)) {
				return true;
			}
		} else {
			/* IRQ */
			if (sil_rew_mem((void*)VIC1_IRQSTATUS) & INTNO_BITPAT(intno)) {
				return true;
			}
		}
	} else {
		intno -= VIC2_INTNO_BASE;
		if (sil_rew_mem((void*)VIC2_INTSELECT) & INTNO_BITPAT(intno)) {
			/* FIQ */
			if (sil_rew_mem((void*)VIC2_FIQSTATUS) & INTNO_BITPAT(intno)) {
				return true;
			}
		} else {
			/* IRQ */
			if (sil_rew_mem((void*)VIC2_IRQSTATUS) & INTNO_BITPAT(intno)) {
				return true;
			}
		}
	}

    return false;
}

#define t_probe_int(intno) x_probe_int(intno)
#define i_probe_int(intno) x_probe_int(intno)

/*
 *  ׵饤°
 *
 */
extern void    x_config_int(INTNO intno, ATR intatr, PRI intpri);

/*
 *  ߥϥɥɬפIRC
 *
 *  AT91SAM7SǤϡɬפʽϤʤ
 */
Inline void
i_begin_int(INTNO intno)
{
}

/*
 *  ߥϥɥνиɬפIRC
 */
Inline void
i_end_int(INTNO intno)
{
}

/*
 *  åȥƥ¸ν
 */
extern void chip_initialize(void);

/*
 *  åȥƥνλ
 *
 *  ƥλ˻Ȥ
 */
extern void chip_exit(void) NoReturn;

/*
 *  atexitνȥǥȥ饯μ¹
 */
Inline void
call_atexit(void)
{
    extern void    software_term_hook(void);
    void (*volatile fp)(void) = software_term_hook;

    /*
     *  software_term_hookؤΥݥ󥿤򡤰övolatileΤfp
     *  ƤȤΤϡ0ȤӤŬǺʤ褦ˤ뤿
     *  Ǥ롥
     */
    if (fp != 0) {
        (*fp)();
    }
}

/*
 *  ߥϥɥchip_support.S
 */
extern void interrupt_handler(void);

/*
 *  ̤γߤäν
 */
extern void default_int_handler(void);

/*
 *  C++٥APIƤӽФ륢ܡȴؿ
 */
Inline void
Toppers_abort(void)
{
	while (1) ;
}

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ¸⥸塼ARMѡ
 */
#include "arm_gcc/common/core_config.h"

#endif /* TOPPERS_CHIP_CONFIG_H */
