/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006-2008 by Task-intelligence Research Group,
 *             Intelligent Systems Research Institute,
 *             National Institute of
 *               Advanced Industrial Science and Technology (AIST), Japan
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *  åװ¸⥸塼 ֥EP93XXѡ
 */

#define  TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#include "kernel_impl.h"


/* Vector Interrupt Controller Register */
#define VIC1_BASE_ASM			0x800B0000
#define VIC2_BASE_ASM			0x800C0000
#define IRQSTATUS_OFFSET		0x0000
#define INTENABLE_OFFSET		0x0010

/*
 *  ٥Υåȥƥ¸ν
 *
 *  ȥåץ⥸塼ǡ˸ƤӽФ롥          
 */
    .text
    .align 2
    .global hardware_init_hook
hardware_init_hook:
	
    /*
	 * Setup the stack for each mode
	 */
    mov     r0, sp
#if 0
	/* Set up Fast Interrupt Mode and set FIQ Mode Stack */
    msr     cpsr_c, #(CPSR_FIQ|CPSR_IRQ_BIT|CPSR_FIQ_BIT)
#endif
	/* Set up Interrupt Mode and set IRQ Mode Stack */
    msr     cpsr_c, #(CPSR_IRQ|CPSR_IRQ_BIT|CPSR_FIQ_BIT)
    mov     r13, r0                 /* Init stack IRQ */

	/* Return Supervisor Mode and set Supervisor Mode */
    msr     cpsr_c, #(CPSR_SVC|CPSR_IRQ_BIT|CPSR_FIQ_BIT)
    mov     pc, lr


/*
 * ߥϥɥ
 *
 * IRQ 㳰٥ƤӽФ
 */
    .text
    .align 2
    .global irq_handler
irq_handler:
    /* 
     * IRQ⡼ɤǼ¹Ԥ
     */
    /* 
     *  Υ⡼(ѡХ⡼)
     *  ܹԤƥȤ¸
     */
    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT) 
    stmfd sp!, {r0-r3, ip, lr, pc} /* pcϥߡ */

    /*
     * spsrϤ뤿IRQ⡼ɤ
     */
    msr   cpsr, #(CPSR_IRQ|CPSR_IRQ_BIT)
    sub   r0, lr, #4
    mrs   r1, spsr

    /*
     *  ߥϥɥ¹ԻΥ⡼ɡʥѡХ⡼ɡˤ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT) 
    str   r0, [sp, #0x18] /* Ϥ򥹥å */
    stmfd sp!, {r1}       /* spsr򥹥å¸ */
    mov   lr, sp          /* λΥåΤ */

    /*
     *  ¿ųߤȽ
     */
    ldr   r2, =excpt_nest_count /* 㳰ߥͥȲ */
    ldr   r3, [r2]
    add   r0, r3, #1            /* 㳰ߥͥȲ򹹿 */
    str   r0, [r2]
    cmp   r3, #0    
    bne   irq_handler_1

    /* 
     * ܤ㳰ʳߡˤʤ饹åѹ
     */
    ldr   r0, =_kernel_istkpt
    ldr   sp, [r0]

irq_handler_1:
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

    /*
     *  װȽ
	 *  ߥơ顢ƥ֤ʳߤ缡
	 *  r3˳ֹ椬ꤵ
     */
	ldr    r0, =VIC1_BASE_ASM	/* 쥸ߥơ */
	ldr    r0, [r0, #IRQSTATUS_OFFSET]
	ldr    r1, =VIC2_BASE_ASM
	ldr    r1, [r1, #IRQSTATUS_OFFSET]

	ldr    r3, =_kernel_ipm_pri_tbl	/* ͥ٥ե饰 */

	/*
	 *  Ʊͥ٤Ǥγߤ̤ͥϡʲ
	 *    VIC1ͥٹˢVIC2ͥ
	 *    ͥ٤,LSBͥٹˢMSBͥ
	 */
irq_get_intpri:
	/*
	 *  ͥ٥٥̡ʥơ֥ι̡ˤװ򸡺
	 *  ٥8
	 */
	/* level 8 */
	ldr    r2, [r3, #56]
	ands   r2, r0, r2
	bne    irq_get_irqnr_vic1
	ldr    r2, [r3, #60]
	ands   r2, r1, r2
	bne    irq_get_irqnr_vic2
	/* level 7 */
	ldr    r2, [r3, #48]
	ands   r2, r0, r2
	bne    irq_get_irqnr_vic1
	ldr    r2, [r3, #52]
	ands   r2, r1, r2
	bne    irq_get_irqnr_vic2
	/* level 6 */
	ldr    r2, [r3, #40]
	ands   r2, r0, r2
	bne    irq_get_irqnr_vic1
	ldr    r2, [r3, #44]
	ands   r2, r1, r2
	bne    irq_get_irqnr_vic2
	/* level 5 */
	ldr    r2, [r3, #32]
	ands   r2, r0, r2
	bne    irq_get_irqnr_vic1
	ldr    r2, [r3, #36]
	ands   r2, r1, r2
	bne    irq_get_irqnr_vic2
	/* level 4 */
	ldr    r2, [r3, #24]
	ands   r2, r0, r2
	bne    irq_get_irqnr_vic1
	ldr    r2, [r3, #28]
	ands   r2, r1, r2
	bne    irq_get_irqnr_vic2
	/* level 3 */
	ldr    r2, [r3, #16]
	ands   r2, r0, r2
	bne    irq_get_irqnr_vic1
	ldr    r2, [r3, #20]
	ands   r2, r1, r2
	bne    irq_get_irqnr_vic2
	/* level 2 */
	ldr    r2, [r3, #8]
	ands   r2, r0, r2
	bne    irq_get_irqnr_vic1
	ldr    r2, [r3, #12]
	ands   r2, r1, r2
	bne    irq_get_irqnr_vic2
	/* level 1 */
	ldr    r2, [r3, #0]
	ands   r2, r0, r2
	bne    irq_get_irqnr_vic1
	ldr    r2, [r3, #4]
	ands   r2, r1, r2
	bne    irq_get_irqnr_vic2

	/*
	 *  Ƚ꤬Фʤä硢¨߽λ
	 */
no_exist_irqnr:
	b      target_ret_int_1

lowest_significant_bit:
	/*        0  1  2  3  4  5  6  7  8  9  10 11 12 13 14 15 */
    .byte  0xFF, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0

irq_get_irqnr_vic1:
	movs   r3, #0
irq_get_irqnr_vic2:
	movne  r3, #32

	/*
	 *  r2:ͥ٤ǥޥװե饰
	 *    r20Ǥʤ
	 *  r3:ֹν
	 *     VIC1װξ硧0VIC2װξ硧32
	 *  ӥåON֤ΤΤǺǤ̤ʥӥåȤΰ֤롥
	 */
	mvn    r0, #0
	tst    r2, r0, lsr #16		/* 16ӥåȤΥå */
	lsreq  r2, r2, #16			/* 16ӥå0ʤΤǡ16ӥåȤ򼡤 */
	addeq  r3, r3, #16			/* å뤿ᱦ˥ե */
	tst    r2, #0xFF			/* 8ӥåȤΥå */
	lsreq  r2, r2, #8			/* 8ӥå0ʤΤǡ8ӥåȤ򼡤 */
	addeq  r3, r3, #8			/* å뤿ᱦ˥ե */
	tst    r2, #0xF				/* 4ӥåȤΥå */
	lsreq  r2, r2, #4			/* 4ӥå0ʤΤǡ4ӥåȤ򼡤 */
	addeq  r3, r3, #4			/* å뤿ᱦ˥ե */
	and    r2, r2, #0xF			/* Ʊߤξξ̥ӥåȤڼΤ */
								/* ǲ̥ӥåȤΰ֤ */
	adr    r0, lowest_significant_bit
	ldrb   r0, [r0, r2]
	add    r3, r3, r0

    /*
     *  װγͥ٤(ǥ)ͥ٥ޥ򥻥å
     *  롥ޤκݡϥɥ¹(ǥ)ͥ٥ޥ
     *  ¸롥
     */
    ldr   r1, =inh_ipm_tbl      /* ͥ٤ */
    ldr   r0, [r1, r3, lsl #2]  /* r1<-ͥ   */
	ldr   r1, =ipm
	ldr   r1, [r1]
	stmfd sp!, {r1}

    /*
     * ϡɥ(IRC)ϳߤդ塤ߤ˱ͥ٥ޥ
     * 򥻥åȤ롥Τ᥽եȥŪˤä˽ϹԤɬפϤʤ
     * եȥŪ(ǥ)ͥ٥ޥ夲ݤˤϡ
     * ͥ٥ޥ˱Ƴ׵ػߥե饰ˤߤػߤ롥
	 *  r0:(ǥ)ͥ
	 *  r3:ֹ
     */
	stmfd sp!, {r0,r3}
	bl    x_set_ipm
	ldmfd sp!, {r0,r3}

    /*
     *  ߥϥɥεưϤ
     */
    ldr   r0, =inh_tbl         /* ߥϥɥơ֥ɤ߽Ф  */
    ldr   r0, [r0, r3, lsl #2] /* r0<-ߥϥɥ            */    

    stmfd sp!,{r3}             /* inhno ¸  */

    /* 
     * ߵ 
     */         
    msr   cpsr, #(CPSR_SVC)

#ifdef LOG_INH_ENTER
    stmfd sp!,{r0}
    mov   r0, r3         /* inhno ѥ᡼    */
    bl    log_inh_enter  /* log_inh_enterƤӽФ */
    ldmfd sp!,{r0}
#endif /* LOG_INH_ENTER */

    /* 
     * ߥϥɥθƤӽФ
     */
    mov   lr, pc
    mov   pc, r0

    ldmfd sp!,{r0}       /* inhno   */    
#ifdef LOG_INH_LEAVE
    bl    log_inh_leave  /* log_inh_leaveƤӽФ */
#endif /* LOG_INH_LEAVE */

    /*
     * ͥγߤػߤ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT)

    b     target_ret_int


/*
 * åȰ¸㳰
 */
    .text
    .global target_exc_handler
target_exc_handler:    
    /*
     *  㳰¹ԤΥ⡼ɡʥѡХ⡼ɡˤ
     *  ߥå֡CPUå֤CPU㳰ȯ
     *  ֤Ѿ롥
     */
    msr   cpsr, #(CPSR_SVC|CPSR_FIQ_BIT|CPSR_IRQ_BIT) 
    str   r0, [sp, #0x18] /* Ϥ򥹥å */
    stmfd sp!, {r1}       /* spsr򥹥å¸ */    
    mov   lr, sp          /* λΥåΤ */

    ldr   r0, =ipm        /* ȯγͥ٥ޥ򥹥å¸ */
    ldr   r1, [r0]              
    stmfd sp!, {r1}

    /* 
     * ƥȽΤᡤexcpt_nest_count 򥹥å¸
     * å¸ߤexcpt_nest_count-1ȼǤ뤬
     * åѤǤǥХåԤ䤹Τǡå
     * ¸롥
     */
    ldr   r0, =excpt_nest_count
    ldr   r1, [r0]
    stmfd sp!, {r1}

    mov   r3,  sp         /* 㳰ե졼Ϥ¸ */

    /*
     *  ¿ųߤȽ
     */
    ldr   r0, =excpt_nest_count
    ldr   r1, [r0]
    add   r1, r1, #1
    str   r1, [r0]
    cmp   r1, #1
    bne   target_exc_handler_1    

    /* 
     * ܤμ¹Ԥʤ饹åѹ
     */
    ldr  r0, =_kernel_istkpt
    ldr  sp, [r0]

target_exc_handler_1:    
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

    /* 
     * ȯγͥ٥ޥ򥹥å¸ 
     * ߥϥɥȽи롼ͭ뤿¸
     */
    ldr   r0, =ipm       
    ldr   r1, [r0]              
    stmfd sp!, {r1}

    /*
     *  CPU㳰ϥɥεưϤ
     */
    ldr   r0, =exch_tbl        /* ߥϥɥơ֥ɤ߽Ф */
    ldr   r1, [r0, r2, lsl #2] /* r1<-㳰ϥɥ                 */

    stmfd sp!,{r2}      /* excno ¸ */
    /* 
     * ߵ 
     * CPUå֡ߥå֤ϷѾ
     */         
    ldr   r0, [lr]
    and   r0, r0, #(CPSR_IRQ_BIT|CPSR_FIQ_BIT)
    orr   r0, r0, #(CPSR_SVC)
    msr   cpsr, r0

#ifdef LOG_EXC_ENTER
    stmfd sp!,{r1,r3}
    mov   r0, r2         /* excno ѥ᡼    */
    bl    log_exc_enter  /* log_exc_enterƤӽФ */
    ldmfd sp!,{r1,r3}
#endif /* LOG_EXC_ENTER */

    /* 
     * CPU㳰ϥɥθƤӽФ
     *
     * 㳰ե졼ƬȤϤ
     */        
    mov   r0, r3
    mov   lr, pc
    mov   pc, r1

    ldmfd sp!,{r0}       /* excno   */    
#ifdef LOG_EXC_LEAVE
    bl    log_exc_leave  /* log_exc_leaveƤӽФ */
#endif /* LOG_EXC_LEAVE */

/*
 * åȰ¸㳰ߤνи
 *
 */

    .global target_ret_exc
target_ret_exc:
    /*
     * ͥγߤػߤ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT)

    .global target_ret_int        
target_ret_int:        
    /*
     * ͥ٥ޥ򸵤᤹
     */
	ldmfd sp!, {r0}
	bl    x_set_ipm

target_ret_int_1:
    /*
     * åݥ󥿤
     */
    ldmfd sp!, {r2}             /* Υåݥ󥿤 */
    mov   sp, r2
    
    /*
     * νARM¸Ǽ¹
     */            
    b     ret_int
