/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006-2008 by Task-intelligence Research Group,
 *             Intelligent Systems Research Institute,
 *             National Institute of
 *               Advanced Industrial Science and Technology (AIST), Japan
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *  ꥢI/OǥХSIO˥ɥ饤СEP93XXѡ
 */

#include <kernel.h>
#include <t_syslog.h>
#include "ep93xx.h"
#include "target_serial.h"

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block 
{
	void* data;
	void* rxsts;
	void* config;
	void* baudrate_h;
	void* baudrate_l;
	void* ctrl;
	void* flag;
	void* intr;
}
SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
struct sio_port_control_block 
{
    const SIOPINIB  *p_siopinib;  /* ꥢI/OݡȽ֥å */
    intptr_t  exinf;              /* ĥ */
    bool_t    openflag;           /* ץѤߥե饰 */
    bool_t    sendflag;           /* ߥ֥͡ե饰 */
    bool_t    getready;           /* ʸ */
    bool_t    putready;           /* ʸǤ */
};

/*
 * ꥢI/OݡȽ֥å
 */
const SIOPINIB siopinib_table[TNUM_SIOP] = {
	{ (void*)UART1_DATA, (void*)UART1_RXSTS, (void*)UART1_CTRL_HIGH,
	  (void*)UART1_CTRL_MID, (void*)UART1_CTRL_LOW,
	  (void*)UART1_CTRL, (void*)UART1_FLAG, (void*)UART1_INTR },
#if TNUM_SIOP >= 2
	{ (void*)UART2_DATA, (void*)UART2_RXSTS, (void*)UART2_CTRL_HIGH,
	  (void*)UART2_CTRL_MID, (void*)UART2_CTRL_LOW,
	  (void*)UART2_CTRL, (void*)UART2_FLAG, (void*)UART2_INTR },
#endif
};

/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
SIOPCB	siopcb_table[TNUM_SIOP];

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)  ((uint_t)((siopid) - 1))
#define get_siopcb(siopid)  (&(siopcb_table[INDEX_SIOP(siopid)]))

/*
 * ʸ?
 */ 
Inline bool_t
uart_getready(SIOPCB *p_siopcb)
{
	if ((sil_rew_mem(p_siopcb->p_siopinib->flag) & UART_FLAG_RXFF) == 0) {
		return false;
	}
	return true;
}

/*
 * ʸǤ뤫?
 */
Inline bool_t
uart_putready(SIOPCB *p_siopcb)
{
	if ((sil_rew_mem(p_siopcb->p_siopinib->flag) & UART_FLAG_TXFE) == 0) {
		return false;
	}
	return true;
}

/*
 *  ʸμФ
 */
Inline uint8_t
uart_getchar(SIOPCB *p_siopcb)
{
	return sil_rew_mem(p_siopcb->p_siopinib->data);
}

/*
 *  ʸν񤭹
 */
Inline void
uart_putchar(SIOPCB *p_siopcb, uint8_t c)
{
	sil_wrw_mem(p_siopcb->p_siopinib->data, c);
}

/*
 *  ߵ
 */
Inline void
uart_enable_send(SIOPCB *p_siopcb)
{
	uint32_t reg;

	reg = sil_rew_mem((void*)p_siopcb->p_siopinib->ctrl);
	reg |= UART_CTRL_TIE;
	sil_wrw_mem((void*)p_siopcb->p_siopinib->ctrl, reg);
}
/*
 *  ߶ػ
 */
Inline void
uart_disable_send(SIOPCB *p_siopcb)
{
	uint32_t reg;

	reg = sil_rew_mem((void*)p_siopcb->p_siopinib->ctrl);
	reg &= ~UART_CTRL_TIE;
	sil_wrw_mem((void*)p_siopcb->p_siopinib->ctrl, reg);
}


/*
 *  ߵ
 */
Inline void
uart_enable_rcv(SIOPCB *p_siopcb)
{
	uint32_t reg;

	reg = sil_rew_mem((void*)p_siopcb->p_siopinib->ctrl);
	reg |= UART_CTRL_RIE;
	sil_wrw_mem((void*)p_siopcb->p_siopinib->ctrl, reg);
}

/*
 *  ߶ػ
 */
Inline void
uart_disable_rcv(SIOPCB *p_siopcb)
{
	uint32_t reg;

	reg = sil_rew_mem((void*)p_siopcb->p_siopinib->ctrl);
	reg &= ~UART_CTRL_RIE;
	sil_wrw_mem((void*)p_siopcb->p_siopinib->ctrl, reg);
}


/*
 *  SIOɥ饤Фν
 */
void
sio_initialize(intptr_t exinf)
{
    SIOPCB  *p_siopcb;
    uint_t  i;

    /*
     *  ꥢI/Oݡȴ֥åν
     */
    for (p_siopcb = siopcb_table, i = 0; i < TNUM_SIOP; p_siopcb++, i++) {
        p_siopcb->p_siopinib = &(siopinib_table[i]);
        p_siopcb->openflag = false;
        p_siopcb->sendflag = false;
    }
}

/*
 * ꥢI/OݡȤΥץ
 */
SIOPCB *
ep93xx_uart_opn_por(SIOPCB *p_siopcb, intptr_t exinf)
{
	uint32_t val;
	uint32_t baud_div;
	const SIOPINIB* psiopinib = p_siopcb->p_siopinib;

	/* UART1ꥻå */
	sil_wrw_mem((void*)psiopinib->ctrl, 0);
	sil_wrw_mem((void*)psiopinib->rxsts, 0);

	/* ƥॳȥν */
	/* ܡ졼ȥå:14.7456MHz */
	val = sil_rew_mem((void*)SYSCON_PWRCNT);
	val |= PWRCNT_UARTBAUD;
	sil_wrw_mem((void*)SYSCON_PWRCNT, val);
	val = sil_rew_mem((void*)SYSCON_DEVICECFG);
	if (psiopinib->data == (void*)UART1_DATA) {
		val |= DEVICECFG_U1EN;
	} else {
		val |= DEVICECFG_U2EN;
	}
	sil_wrw_mem((void*)SYSCON_DEVICECFG, val);

	/* ǡĹ:8ӥåȡ1ȥåץӥåȡѥƥʤFIFO̤ */
	sil_wrw_mem((void*)psiopinib->config, 0x60);

	/* ܡ졼Ȥ */
	baud_div = (UARTCLK >> 4) / BAUD_RATE_SETTING - 1;
	sil_wrw_mem((void*)psiopinib->baudrate_h, (baud_div >> 8) & 0xFF);
	sil_wrw_mem((void*)psiopinib->baudrate_l, baud_div & 0xFF);

	/* UART1ͭ */
	sil_wrw_mem((void*)psiopinib->ctrl, 0x01);

    p_siopcb->exinf = exinf;
    p_siopcb->getready = p_siopcb->putready = false;
    p_siopcb->openflag = true;

    return(p_siopcb);
}


/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
sio_opn_por(ID siopid, intptr_t exinf)
{
    SIOPCB  *p_siopcb = get_siopcb(siopid);
    bool_t  opnflg;
    ER      ercd;

    /*
     *  ץ󤷤ݡȤ뤫opnflgɤǤ
     */
    opnflg = p_siopcb->openflag;

    /*
     *  ǥХ¸Υץ
     */
    ep93xx_uart_opn_por(p_siopcb, exinf);

    /*
     *  ꥢI/OߤΥޥ롥
     */
    if (!opnflg) {
        ercd = ena_int(INTNO_SIO);
        assert(ercd == E_OK);
    }
    return(p_siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
sio_cls_por(SIOPCB *p_siopcb)
{
    /*
     *  ǥХ¸Υ
     */
    const SIOPINIB  *p_siopinib;

    p_siopinib = p_siopcb->p_siopinib;
	sil_wrw_mem(p_siopcb->p_siopinib->ctrl, 0);
    p_siopcb->openflag = false;
    
    /*
     *  ꥢI/Oߤޥ롥
     */
    dis_int(INTNO_SIO);    
}

/*
 *  SIOγߥϥɥ
 */
void
sio_isr(ID siopid)
{
    SIOPCB *p_siopcb = &(siopcb_table[INDEX_SIOP(siopid)]);

    if (uart_getready(p_siopcb)) {
        /*
         *  ΥХå롼ƤӽФ
         */
        sio_irdy_rcv(p_siopcb->exinf);
    }
    if (uart_putready(p_siopcb)) {
        /*
         *  ǽХå롼ƤӽФ
         */
        sio_irdy_snd(p_siopcb->exinf);
    }    
}

/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
sio_snd_chr(SIOPCB *siopcb, char_t c)
{
    if (uart_putready(siopcb)) {
        uart_putchar(siopcb, c);
        return(true);
    }
    return(false);
}

/*
 *  ꥢI/OݡȤʸ
 */
int_t
sio_rcv_chr(SIOPCB *siopcb)
{
    if (uart_getready(siopcb)) {
        return((int_t)(uint8_t) uart_getchar(siopcb));
    }
    return(false);
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
        case SIO_RDY_SND:
            uart_enable_send(siopcb);
            break;
        case SIO_RDY_RCV:
            uart_enable_rcv(siopcb);
            break;
    }
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
        case SIO_RDY_SND:
            uart_disable_send(siopcb);
            break;
        case SIO_RDY_RCV:
            uart_disable_rcv(siopcb);
            break;
    }
}
