/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2007-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006-2008 by Task-intelligence Research Group,
 *             Intelligent Systems Research Institute,
 *             National Institute of
 *               Advanced Industrial Science and Technology (AIST), Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id$
 */
#include "kernel_impl.h"


#define PAGE_TABLE_SIZE		0x1000		/* 4096 */

/*
 * MMU֘A
 */
static uint32_t PageTable[PAGE_TABLE_SIZE] __attribute__ ((aligned (0x4000)));

/*
 * y[We[ũZNVݒ
 */
static void mmu_map_section(uintptr_t va, uintptr_t pa, uint8_t dom,
							uint8_t ap, uint8_t cb)
{
	uint32_t ttb;
	uint32_t *sptr;

	CP15_READ_TTB(ttb);

	sptr = (uint32_t*)((ttb & 0xFFFFC000) | (((va >> 20) & 0x00000FFF) << 2));
	*sptr = pa | (ap << 10) | (dom << 5) | (1 << 4) | (cb << 2) | MMU_L1_ENTRY_SECTION;
}

/*
 * }bsO
 */
void mmu_map_region(MEMORY_ATTRIBUTE *pattr)
{
	uint32_t pgsize = pattr->pgsize;
	uintptr_t va = pattr->va;
	uintptr_t pa = pattr->pa;

	while (pgsize > 0) {
		mmu_map_section(va, pa, pattr->dom, pattr->ap, pattr->cb);

		va += MAPPING_SIZE_1M;
		pa += MAPPING_SIZE_1M;
		pgsize--;
	}
}

/*
 * MMU
 */
void ep93xx_mmu_initialize(void)
{
	MEMORY_ATTRIBUTE mattr;
	uint32_t ctrl;

	/* ϊe[u̐ݒ */
	CP15_WRITE_TTB((uint32_t)PageTable & 0xFFFFC000);

	/*
	 * SZNV𕨗AhX=zAhX
	 * mLbVuAmobt@u
	 */
	mattr.pa = 0x00000000;
	mattr.va = 0x00000000;
	mattr.pgsize = 4096;
	mattr.ap = RWRW;
	mattr.cb = NON_CACH_NON_BUFF;
	mattr.dom = 0;

	mmu_map_region(&mattr);

	/*
	 * ^[QbgˑłMMȔ
	 */
	target_mmu_initialize();

	/*
	 * hCԍ̐ݒ
	 */
	CP15_WRITE_DOMAIN(1);

	/*
	 * MMUL
	 */
	CP15_READ_CONTROL(ctrl);
	ctrl |= CTRL_MMU_ENABLE | CTRL_WRBUF_ENABLE | CTRL_DCACHE_ENABLE | CTRL_ICACHE_ENABLE;
	CP15_WRITE_CONTROL(ctrl);
}
