/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2007-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006-2008 by Task-intelligence Research Group,
 *             Intelligent Systems Research Institute,
 *             National Institute of
 *               Advanced Industrial Science and Technology (AIST), Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: $
 */

#ifndef  TOPPERS_EP93XX_H
#define TOPPERS_EP93XX_H

#include <sil.h>

/* IO Register Map */
#define IO_REG_BASE			(0x80000000UL)

#define AHB_PERIPH_BASE		(IO_REG_BASE)
#define APB_PERIPH_BASE		(IO_REG_BASE + 0x00800000UL)

/* BUS:AHB */
#define DMA_OFFSET			0x000000
#define DMA_BASE			(AHB_PERIPH_BASE + DMA_OFFSET)
#define MAC_OFFSET			0x010000
#define MAC_BASE			(AHB_PERIPH_BASE + MAC_OFFSET)
#define USB_OFFSET			0x020000
#define USB_BASE			(AHB_PERIPH_BASE + USB_OFFSET)
#define RASTER_OFFSET		0x030000
#define RASTER_BASE			(AHB_PERIPH_BASE + RASTER_OFFSET)
#define SDRAM_OFFSET		0x060000
#define SDRAM_BASE			(AHB_PERIPH_BASE + SDRAM_OFFSET)
#define SRAM_OFFSET			0x080000
#define SRAM_BASE			(AHB_PERIPH_BASE + SRAM_OFFSET)
#define BOOT_OFFSET			0x090000
#define BOOT_BASE			(AHB_PERIPH_BASE + BOOT_OFFSET)
#define IDE_OFFSET			0x0A0000
#define IDE_BASE			(AHB_PERIPH_BASE + IDE_OFFSET)
#define VIC1_OFFSET			0x0B0000
#define VIC1_BASE			(AHB_PERIPH_BASE + VIC1_OFFSET)
#define VIC2_OFFSET			0x0C0000
#define VIC2_BASE			(AHB_PERIPH_BASE + VIC2_OFFSET)

/* BUS:APB */
#define TIMERS_OFFSET		0x010000
#define TIMERS_BASE			(APB_PERIPH_BASE + TIMERS_OFFSET)
#define I2S_OFFSET			0x020000
#define I2S_BASE			(APB_PERIPH_BASE + I2S_OFFSET)
#define SECURITY_OFFSET		0x030000
#define SECURITY_BASE		(APB_PERIPH_BASE + SECURITY_OFFSET)
#define GPIO_OFFSET			0x040000
#define GPIO_BASE			(APB_PERIPH_BASE + GPIO_OFFSET)
#define AAC_OFFSET			0x080000
#define AAC_BASE			(APB_PERIPH_BASE + AAC_OFFSET)
#define SPI_OFFSET			0x0A0000
#define SPI_BASE			(APB_PERIPH_BASE + SPI_OFFSET)
#define IRDA_OFFSET			0x0B0000
#define IRDA_BASE			(APB_PERIPH_BASE + IRDA_OFFSET)
#define UART1_OFFSET		0x0C0000
#define UART1_BASE			(APB_PERIPH_BASE + UART1_OFFSET)
#define UART2_OFFSET		0x0D0000
#define UART2_BASE			(APB_PERIPH_BASE + UART2_OFFSET)
#define UART3_OFFSET		0x0E0000
#define UART3_BASE			(APB_PERIPH_BASE + UART3_OFFSET)
#define KEY_OFFSET			0x0F0000
#define KEY_BASE			(APB_PERIPH_BASE + KEY_OFFSET)
#define TOUCH_OFFSET		0x100000
#define TOUCH_BASE			(APB_PERIPH_BASE + TOUCH_OFFSET)
#define PWM_OFFSET			0x110000
#define PWM_BASE			(APB_PERIPH_BASE + PWM_OFFSET)
#define RTC_OFFSET			0x120000
#define RTC_BASE			(APB_PERIPH_BASE + RTC_OFFSET)
#define SYSCON_OFFSET		0x130000
#define SYSCON_BASE			(APB_PERIPH_BASE + SYSCON_OFFSET)
#define WATCHDOG_OFFSET		0x140000
#define WATCHDOG_BASE		(APB_PERIPH_BASE + WATCHDOG_OFFSET)

/* System Controller */
#define SYSCON_PWRCNT		(SYSCON_BASE + 0x0004)
#define SYSCON_CLKSET1		(SYSCON_BASE + 0x0020)
#define SYSCON_CLKSET2		(SYSCON_BASE + 0x0024)
#define SYSCON_DEVICECFG	(SYSCON_BASE + 0x0080)
#define SYSCON_SYSSWLOCK	(SYSCON_BASE + 0x00C0)

#define PWRCNT_UARTBAUD		(0x01 << 29)
#define DEVICECFG_U1EN		(0x01 << 18)
#define DEVICECFG_U2EN		(0x01 << 20)
#define DEVICECFG_U3EN		(0x01 << 24)

/* VIC1 */
#define VIC1_IRQSTATUS		(VIC1_BASE + 0x0000)
#define VIC1_FIQSTATUS		(VIC1_BASE + 0x0004)
#define VIC1_RAWINTR		(VIC1_BASE + 0x0008)
#define VIC1_INTSELECT		(VIC1_BASE + 0x000C)
#define VIC1_INTENABLE		(VIC1_BASE + 0x0010)
#define VIC1_INTENCLEAR		(VIC1_BASE + 0x0014)
#define VIC1_SOFTINT		(VIC1_BASE + 0x0018)
#define VIC1_SOFINTCLEAR	(VIC1_BASE + 0x001C)
#define VIC1_PROTECTION		(VIC1_BASE + 0x0020)
#define VIC1_VECTADDR		(VIC1_BASE + 0x0030)
#define VIC1_DEFVECTADDR	(VIC1_BASE + 0x0034)
#define VIC1_VECTADDR0		(VIC1_BASE + 0x0100)

#define VIC1_VECTCNTL0		(VIC1_BASE + 0x0200)

#define VIC1_PERIPHEID0		(VIC1_BASE + 0x0FE0)
#define VIC1_PERIPHEID0		(VIC1_BASE + 0x0FE0)
#define VIC1_PERIPHEID0		(VIC1_BASE + 0x0FE0)
#define VIC1_PERIPHEID0		(VIC1_BASE + 0x0FE0)

/* VIC2 */
#define VIC2_IRQSTATUS		(VIC2_BASE + 0x0000)
#define VIC2_FIQSTATUS		(VIC2_BASE + 0x0004)
#define VIC2_RAWINTR		(VIC2_BASE + 0x0008)
#define VIC2_INTSELECT		(VIC2_BASE + 0x000C)
#define VIC2_INTENABLE		(VIC2_BASE + 0x0010)
#define VIC2_INTENCLEAR		(VIC2_BASE + 0x0014)
#define VIC2_SOFTINT		(VIC2_BASE + 0x0018)
#define VIC2_SOFINTCLEAR	(VIC2_BASE + 0x001C)
#define VIC2_PROTECTION		(VIC2_BASE + 0x0020)
#define VIC2_VECTADDR		(VIC2_BASE + 0x0030)
#define VIC2_DEFVECTADDR	(VIC2_BASE + 0x0034)
#define VIC2_VECTADDR0		(VIC2_BASE + 0x0100)

#define VIC2_VECTCNTL0		(VIC2_BASE + 0x0200)

#define VIC2_PERIPHEID0		(VIC2_BASE + 0x0FE0)
#define VIC2_PERIPHEID0		(VIC2_BASE + 0x0FE0)
#define VIC2_PERIPHEID0		(VIC2_BASE + 0x0FE0)
#define VIC2_PERIPHEID0		(VIC2_BASE + 0x0FE0)

/* UART1 */
#define UART1_DATA			(UART1_BASE)
#define UART1_RXSTS			(UART1_BASE + 0x0004)
#define UART1_CTRL_HIGH		(UART1_BASE + 0x0008)
#define UART1_CTRL_MID		(UART1_BASE + 0x000C)
#define UART1_CTRL_LOW		(UART1_BASE + 0x0010)
#define UART1_CTRL			(UART1_BASE + 0x0014)
#define UART1_FLAG			(UART1_BASE + 0x0018)
#define UART1_INTR			(UART1_BASE + 0x001C)

/* UART2 */
#define UART2_DATA			(UART2_BASE)
#define UART2_RXSTS			(UART2_BASE + 0x0004)
#define UART2_CTRL_HIGH		(UART2_BASE + 0x0008)
#define UART2_CTRL_MID		(UART2_BASE + 0x000C)
#define UART2_CTRL_LOW		(UART2_BASE + 0x0010)
#define UART2_CTRL			(UART2_BASE + 0x0014)
#define UART2_FLAG			(UART2_BASE + 0x0018)
#define UART2_INTR			(UART2_BASE + 0x001C)

#define UART_FLAG_TXFE		(0x01 << 7)
#define UART_FLAG_RXFF		(0x01 << 6)
#define UART_CTRL_TIE		(0x01 << 5)
#define UART_CTRL_RIE		(0x01 << 4)
#define UART_CTRL_UARTE		(0x01)

/* Timers */
#define TIMER1_LOAD			(TIMERS_BASE)
#define TIMER1_VALUE		(TIMERS_BASE + 0x0004)
#define TIMER1_CONTROL		(TIMERS_BASE + 0x0008)
#define TIMER1_CLEAR		(TIMERS_BASE + 0x000C)

#define TIMER_CTRL_ENABLE	(0x01 << 7)
#define TIMER_CTRL_PERIODIC	(0x01 << 6)
#define TIMER_CTRL_508KHZ	(0x01 << 3)

/* GPIO */
#define GPIO_PADR			(GPIO_BASE)
#define GPIO_PBDR			(GPIO_BASE + 0x0004)
#define GPIO_PCDR			(GPIO_BASE + 0x0008)
#define GPIO_PDDR			(GPIO_BASE + 0x000C)
#define GPIO_PADDR			(GPIO_BASE + 0x0010)
#define GPIO_PBDDR			(GPIO_BASE + 0x0014)
#define GPIO_PCDDR			(GPIO_BASE + 0x0018)
#define GPIO_PDDDR			(GPIO_BASE + 0x001C)
#define GPIO_PEDR			(GPIO_BASE + 0x0020)
#define GPIO_PEDDR			(GPIO_BASE + 0x0024)
#define GPIO_PFDR			(GPIO_BASE + 0x0030)
#define GPIO_PFDDR			(GPIO_BASE + 0x0034)
#define GPIO_PGDR			(GPIO_BASE + 0x0038)
#define GPIO_PGDDR			(GPIO_BASE + 0x003C)
#define GPIO_PHDR			(GPIO_BASE + 0x0040)
#define GPIO_PHDDR			(GPIO_BASE + 0x0044)
#define GPIO_GPIOFIntType1	(GPIO_BASE + 0x004C)
#define GPIO_GPIOFIntType2	(GPIO_BASE + 0x0050)
#define GPIO_GPIOFEOI		(GPIO_BASE + 0x0054)
#define GPIO_GPIOFIntEn		(GPIO_BASE + 0x0058)
#define GPIO_IntStsF		(GPIO_BASE + 0x005C)
#define GPIO_RawIntStsF		(GPIO_BASE + 0x0060)
#define GPIO_GPIOFDB		(GPIO_BASE + 0x0064)
#define GPIO_GPIOAIntType1	(GPIO_BASE + 0x0090)
#define GPIO_GPIOAIntType2	(GPIO_BASE + 0x0094)
#define GPIO_GPIOAEOI		(GPIO_BASE + 0x0098)
#define GPIO_GPIOAIntEn		(GPIO_BASE + 0x009C)
#define GPIO_IntStsA		(GPIO_BASE + 0x00A0)
#define GPIO_RawIntStsA		(GPIO_BASE + 0x00A4)
#define GPIO_GPIOADB		(GPIO_BASE + 0x00A8)
#define GPIO_GPIOBIntType1	(GPIO_BASE + 0x00AC)
#define GPIO_GPIOBIntType2	(GPIO_BASE + 0x00B0)
#define GPIO_GPIOBEOI		(GPIO_BASE + 0x00B4)
#define GPIO_GPIOBIntEn		(GPIO_BASE + 0x00B8)
#define GPIO_IntStsB		(GPIO_BASE + 0x00BC)
#define GPIO_RawIntStsB		(GPIO_BASE + 0x00C0)
#define GPIO_GPIOBPDB		(GPIO_BASE + 0x00C4)
#define GPIO_EEDrive		(GPIO_BASE + 0x00C8)

/* Interrupt Configuration */
#define VIC_INTNO_COMMRX		(2)
#define VIC_INTNO_COMMTX		(3)
#define VIC_INTNO_TC1UI			(4)
#define VIC_INTNO_TC2UI			(5)
#define VIC_INTNO_AACINTR		(6)
#define VIC_INTNO_DMAM2P0		(7)
#define VIC_INTNO_DMAM2P1		(8)
#define VIC_INTNO_DMAM2P2		(9)
#define VIC_INTNO_DMAM2P3		(10)
#define VIC_INTNO_DMAM2P4		(11)
#define VIC_INTNO_DMAM2P5		(12)
#define VIC_INTNO_DMAM2P6		(13)
#define VIC_INTNO_DMAM2P7		(14)
#define VIC_INTNO_DMAM2P8		(15)
#define VIC_INTNO_DMAM2P9		(16)
#define VIC_INTNO_DMAM2M0		(17)
#define VIC_INTNO_DMAM2M1		(18)
#define VIC_INTNO_UART1RXINTR1	(23)
#define VIC_INTNO_UART1TXINTR1	(24)
#define VIC_INTNO_UART2RXINTR2	(25)
#define VIC_INTNO_UART2TXINTR2	(26)
#define VIC_INTNO_UART3RXINTR3	(27)
#define VIC_INTNO_UART3TXINTR3	(28)
#define VIC_INTNO_INT_KEY		(29)
#define VIC_INTNO_INT_TOUCH		(30)
#define VIC_INTNO_INT_EXT0		(32)
#define VIC_INTNO_INT_EXT1		(33)
#define VIC_INTNO_INT_EX2		(34)
#define VIC_INTNO_TINTR			(35)
#define VIC_INTNO_WEINT			(36)
#define VIC_INTNO_INT_RTC		(37)
#define VIC_INTNO_INT_IRDA		(38)
#define VIC_INTNO_INT_MAC		(39)
#define VIC_INTNO_INT_PROG		(41)
#define VIC_INTNO_CLK1HZ		(42)
#define VIC_INTNO_V_SYNC		(43)
#define VIC_INTNO_INT_VIDEO_FIFO	(44)
#define VIC_INTNO_INT_SSP1RX	(45)
#define VIC_INTNO_INT_SSP1TX	(46)
#define VIC_INTNO_TC3UI			(51)
#define VIC_INTNO_INT_UART1		(52)
#define VIC_INTNO_SSPINTR		(53)
#define VIC_INTNO_INT_UART2		(54)
#define VIC_INTNO_INT_UART3		(55)
#define VIC_INTNO_USHINTR		(56)
#define VIC_INTNO_INT_PME		(57)
#define VIC_INTNO_INT_DSP		(58)
#define VIC_INTNO_GPIOINTR		(59)
#define VIC_INTNO_I2SINTR		(60)

#define VIC1_INTNO_BASE			(0)
#define VIC1_INTNUM				(32)
#define VIC2_INTNO_BASE			VIC1_INTNUM
#define VIC2_INTNUM				(64)

/*
 * ݃nhԍrbgp^[߂}N
 */
#define INTNO_BITPAT(intno)		(0x01 << ((intno) & 0x1F))

/*
 * UART{[[g
 */
#define BAUD_RATE_SETTING		(115200)

/*
 * eytF̃\[XNbNl
 */
#define UARTCLK					(14745600) /* UARTpNbN(14.7456MHz) */
#define CLK_SRC_RATE			(14745600)

#ifndef TOPPERS_MACRO_ONLY
        
/*
 * VXebN֐
 */
#define lock_syscon()		sil_wrw_mem((void*)SYSCON_SYSSWLOCK, 0xAA)
#define unlock_syscon()		sil_wrw_mem((void*)SYSCON_SYSSWLOCK, 0xAA)
#define is_locked_syscon()	(sil_rew_mem((void*)SYSCON_SYSSWLOCK) ? false : true)

/*
 * J[lÑOo͗p̏
 */
Inline void
ep93xx_init_uart(void)
{
	uint32_t val;

	/* UART1Zbg */
	sil_wrw_mem((void*)UART1_CTRL, 0);
	sil_wrw_mem((void*)UART1_RXSTS, 0);

	/* VXeRg[̏ݒ */
	/* {[[g\[XNbN:14.7456MHz */
	val = sil_rew_mem((void*)SYSCON_PWRCNT);
	val |= PWRCNT_UARTBAUD;
	sil_wrw_mem((void*)SYSCON_PWRCNT, val);
	val = sil_rew_mem((void*)SYSCON_DEVICECFG);
	val |= DEVICECFG_U1EN;
	sil_wrw_mem((void*)SYSCON_DEVICECFG, val);

	/* f[^:8rbgC1XgbvrbgCpeBȂCFIFOgp */
	sil_wrw_mem((void*)UART1_CTRL_HIGH, 0x60);
	sil_wrw_mem((void*)UART1_CTRL_MID, 0x00);
	sil_wrw_mem((void*)UART1_CTRL_LOW, 0x07);

	/* UART1̗L */
	sil_wrw_mem((void*)UART1_CTRL, 0x01);
}

/*
 *  UART̃|[Oo
 */
Inline void
ep93xx_putc(char_t c)
{
	while ((sil_rew_mem((void*)UART1_FLAG) & UART_FLAG_TXFE) == 0) ;
	sil_wrw_mem((void*)UART1_DATA, c);
}

/*
 * UART̃|[O
 */
Inline char_t
ep93xx_getc(void)
{
	while ((sil_rew_mem((void*)UART1_FLAG) & UART_FLAG_RXFF) == 0) ;
	return sil_rew_mem((void*)UART1_DATA);
}

/*
 * I
 */
Inline void
ep93xx_exit(void)
{    
}

/*
 * VXeRvZbTiCP15j֘A
 */
#define CP15_READ_CONTROL(x)	Asm("mrc p15, 0, %0, c1, c0, 0":"=r"(x))
#define CP15_WRITE_CONTROL(x)	Asm("mcr p15, 0, %0, c1, c0, 0"::"r"(x))
#define CP15_READ_TTB(x)	Asm("mrc p15, 0, %0, c2, c0, 0":"=r"(x))
#define CP15_WRITE_TTB(x)	Asm("mcr p15, 0, %0, c2, c0, 0"::"r"(x))
#define CP15_WRITE_DOMAIN(x)	Asm("mcr p15, 0, %0, c3, c0, 0"::"r"(x))

/* Register 1 */
#define CTRL_VECT_HIGH		(0x01 << 13)
#define CTRL_ICACHE_ENABLE	(0x01 << 12)
#define CTRL_WRBUF_ENABLE	(0x01 << 3)
#define CTRL_DCACHE_ENABLE	(0x01 << 2)
#define CTRL_MMU_ENABLE		(0x01)

/*
 *  MMU֘A
 */
#define NANA		0x00
#define RWNA		0x01
#define RWRO		0x02
#define RWRW		0x03

#define NON_CACH_NON_BUFF	0
#define NON_CACH_BUF		1
#define WRITE_THROW			2
#define WRITE_BUFFER		3

#define MAPPING_SIZE_1M		(0x100000)
#define MAPPING_SIZE		MAPPING_SIZE_1M
#define PG_SIZE(x)			(((x) + MAPPING_SIZE - 1) / MAPPING_SIZE)

#define MMU_L1_ENTRY_SECTION	(0x02)
#define MMU_L1_ENTRY_COARSE_PT	(0x01)
#define MMU_L1_ENTRY_FINE_PT	(0x03)
#define MMU_L1_ENTRY_FAULT		(0x00)
#define MMU_L2_ENTRY_LARGE		(0x01)
#define MMU_L2_ENTRY_SMALL		(0x02)
#define MMU_L2_ENTRY_TINY		(0x03)
#define MMU_L2_ENTRY_FAULT		(0x00)

/*
 * ϊe[uւ̐ݒe
 * va   : zAhX
 * pa   : AhX
 * size : TCY 
 * ap   : ANZX
 * cb    : LbVCobt@
 * dom  : hCrbg
 */
typedef struct{
    uintptr_t   va;
    uintptr_t   pa;
    uint32_t    pgsize;
    uint8_t     ap;
    uint8_t     cb;
	uint8_t     dom;
} MEMORY_ATTRIBUTE;

extern void ep93xx_mmu_initialize(void);
extern void mmu_map_region(MEMORY_ATTRIBUTE *pattr);
     
#endif /* TOPPPERS_MACRO_ONLY */


#endif	/* TOPPERS_EP93XX_H */
