/*
 * EP93XXΥ󥫥ץ
 */

OUTPUT_FORMAT("elf32-littlearm", "elf32-bigarm", "elf32-littlearm")
OUTPUT_ARCH(arm)

PROVIDE(hardware_init_hook = 0);
PROVIDE(software_init_hook = 0);
PROVIDE(software_term_hook = 0);
STARTUP(start.o)

SECTIONS
{
	. = ALIGN(16);
	.vector_table :					/* Exception table */
	{
		__start_vector_table = .;
		*(.vector)
		__end_vector_table = .;
	} > SDRAM
	
	. = ALIGN(4);

	__text_start_flash = .;

    .init           : AT(__text_start_flash)
    {
      KEEP (*(.init))
    } > SDRAM = 0
    .text :
    {
        *(.text)
        *(.text.*)
 	   . = ALIGN(8);
    } > SDRAM = 0
    .fini           :
    {
      KEEP (*(.fini))
    } > SDRAM = 0
	PROVIDE (__etext = .);
	PROVIDE (_etext = .);
	PROVIDE (etext = .);


    .eh_frame       : ONLY_IF_RO { KEEP (*(.eh_frame)) } > SDRAM
    .eh_frame       : ONLY_IF_RW { KEEP (*(.eh_frame)) } > SDRAM
    .ARM.extab   : { *(.ARM.extab* .gnu.linkonce.armextab.*) } > SDRAM
    __exidx_start = .;
    .ARM.exidx   : { *(.ARM.exidx* .gnu.linkonce.armexidx.*) } > SDRAM
    __exidx_end = .;
    .init_array     :
    {
       PROVIDE_HIDDEN (__init_array_start = .);
       KEEP (*(SORT(.init_array.*)))
       KEEP (*(.init_array))
       PROVIDE_HIDDEN (__init_array_end = .);
    } > SDRAM
    .fini_array     :
    {
      PROVIDE_HIDDEN (__fini_array_start = .);
      KEEP (*(.fini_array))
      KEEP (*(SORT(.fini_array.*)))
      PROVIDE_HIDDEN (__fini_array_end = .);
    } > SDRAM
    .jcr            : { KEEP (*(.jcr)) } > SDRAM

	. = ALIGN(8);

    .rodata :
    {
        *(.rodata)
        *(.rodata.*)
 	   . = ALIGN(8);
    } > SDRAM = 0

	. = ALIGN(8);

	__text_end_flash = .;

    __idata_start_flash = __text_end_flash;
    __idata_start = .;
    .data : AT (__idata_start_flash)
    {
        __data_start = ABSOLUTE(.);
        *(vtable)
        *(.data)
        *(.data.*)
    } > SDRAM =0
	__idata_end =  __idata_start + SIZEOF(.data);
    _edata = .;
    PROVIDE(edata = .);

   . = ALIGN(4);

    .bss :
    {
        __bss_start  = ABSOLUTE(.);
        *(.bss)
        *(.bss.*)
        *(COMMON)
        . = ALIGN(4);
		__bss_end = ABSOLUTE(.);
    } > SDRAM
    . = ALIGN(4);

	.region ALIGN(0x100000) (NOLOAD) :
	{
		__region_start = ABSOLUTE(.);
		*(.region.*)
		__region_end = ABSOLUTE(.);
	} > SDRAM

	. = ALIGN(4);
    _end = .;
    PROVIDE(end = .);

    .comment 0 : { *(.comment) }
    /* DWARF debug sections.
       Symbols in the DWARF debugging sections are relative to the beginning
       of the section so we begin them at 0.  */
    /* DWARF 1 */
    .debug          0 : { *(.debug) }
    .line           0 : { *(.line) }
    /* GNU DWARF 1 extensions */
    .debug_srcinfo  0 : { *(.debug_srcinfo) }
    .debug_sfnames  0 : { *(.debug_sfnames) }
    /* DWARF 1.1 and DWARF 2 */
    .debug_aranges  0 : { *(.debug_aranges) }
    .debug_pubnames 0 : { *(.debug_pubnames) }
    /* DWARF 2 */
    .debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }
    .debug_abbrev   0 : { *(.debug_abbrev) }
    .debug_line     0 : { *(.debug_line) }
    .debug_frame    0 : { *(.debug_frame) }
    .debug_str      0 : { *(.debug_str) }
    .debug_loc      0 : { *(.debug_loc) }
    .debug_macinfo  0 : { *(.debug_macinfo) }
    /* SGI/MIPS DWARF 2 extensions */
    .debug_weaknames 0 : { *(.debug_weaknames) }
    .debug_funcnames 0 : { *(.debug_funcnames) }
    .debug_typenames 0 : { *(.debug_typenames) }
    .debug_varnames  0 : { *(.debug_varnames) }
    /* DWARF 3 */
    .debug_pubtypes 0 : { *(.debug_pubtypes) }
    .debug_ranges   0 : { *(.debug_ranges) }
}
