/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006-2008 by Task-intelligence Research Group,
 *             Intelligent Systems Research Institute,
 *             National Institute of
 *               Advanced Industrial Science and Technology (AIST), Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: $
 */

#ifndef __OPENRTM_SETUP_H__
#define __OPENRTM_SETUP_H__

#ifndef EOF
#define EOF	0xFF
#endif /* EOF */

/*
 *  ݒ胂[hڍs肷邽߂̃sl
 *    JP1(PB:8)̏ԂŔ肷
 *    V[g(ON):ڍs^I[v(OFF):ڍsȂ
 */
#define CONFIG_MODE_BIT		0x80

/* AhX` */
#define FLASH_BASE_ADDR       (0x60000000)
#define FLASH_CONFIG_ADDR     (0x603f0000)
#define FLASH_CONFIG_SIZE     (0x2000)
#define BLOCK_SIZE            (0x10000)
#define WRITE_SIZE            (0x2000)

/*
 * RtBÕf[^Jnʒu
 *   ŏ8oCg̓}WbNio[pɊm
 *   RtBO擪{8oCgf[^̊Jnʒu
 */
#define FLASH_CONFIG_DATA_START	(FLASH_CONFIG_ADDR + FLASH_MAGICWORD_SIZE)
#define GET_CONFIG_DATA_STR()	FLASH_CONFIG_DATA_START

/* }WbNio[ */
#define FLASH_MAGICWORD_SIZE  (8)

void flash_writer(uint32_t from, uint32_t to, uint32_t base, uint32_t size);
void OpenRTMSetup();
uint32_t checkMagicWordForFlash( void );
void setMagicWord(void);
void getNameServerAddr( int8_t* addr );
bool_t getConfigContent( uint8_t const * pname, uint8_t* cdata, int_t clen );

#endif /* __OPENRTM_SETUP_H__ */
