/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006-2008 by Task-intelligence Research Group,
 *             Intelligent Systems Research Institute,
 *             National Institute of
 *               Advanced Industrial Science and Technology (AIST), Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: $
 */

#include <kernel.h>
#include <sil.h>
#include "ep93xx.h"
#include "led.h"

#define PORT_LED_R		(0x01 << 6)
#define PORT_LED_Y		(0x01 << 7)

/*
 * LED
 */
static uint_t map_led(uint_t n)
{
	uint_t port = 0;

	switch(n) {
	case LED_R:
		port =  PORT_LED_R;
		break;
	case LED_Y:
		port = PORT_LED_Y;
		break;
	default:
		break;
	}

	return port;
}

void init_led()
{
	/*
	 * GPIO_A:6 LED1iԁj
	 * CPIO_A:7 LED2ij
	 */

	/* |[go͒l */
	sil_andw((void*)GPIO_PADR, ~(PORT_LED_R | PORT_LED_Y));
	/* |[go͂ɐݒ */
	sil_orw((void*)GPIO_PADDR, PORT_LED_R | PORT_LED_Y);
}

void set_led(uint_t n, bool_t v)
{
	uint_t port;

	port = map_led(n);

	if (v) {
		sil_orw((void*)GPIO_PADR, port);
	} else {
		sil_andw((void*)GPIO_PADR, ~port);
	}
}

void toggle_led(uint_t n)
{
	uint32_t b;
	uint_t port;

	port = map_led(n);
	b = sil_rew_mem((void*)GPIO_PADR);

	if (b & port) {
		sil_andw((void*)GPIO_PADR, ~port);
	} else {
		sil_orw((void*)GPIO_PADR, port);
	}
}


