/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006-2008 by Task-intelligence Research Group,
 *             Intelligent Systems Research Institute,
 *             National Institute of
 *               Advanced Industrial Science and Technology (AIST), Japan
 * 
 *  $B>e5-Cx:n8"<T$O!$0J2<$N(B(1)$B!A(B(4)$B$N>r7o$rK~$?$9>l9g$K8B$j!$K\%=%U%H%&%'(B
 *  $B%"!JK\%=%U%H%&%'%"$r2~JQ$7$?$b$N$r4^$`!%0J2<F1$8!K$r;HMQ!&J#@=!&2~(B
 *  $BJQ!&:FG[I[!J0J2<!$MxMQ$H8F$V!K$9$k$3$H$rL5=~$G5vBz$9$k!%(B
 *  (1) $BK\%=%U%H%&%'%"$r%=!<%9%3!<%I$N7A$GMxMQ$9$k>l9g$K$O!$>e5-$NCx:n(B
 *      $B8"I=<(!$$3$NMxMQ>r7o$*$h$S2<5-$NL5J]>Z5,Dj$,!$$=$N$^$^$N7A$G%=!<(B
 *      $B%9%3!<%ICf$K4^$^$l$F$$$k$3$H!%(B
 *  (2) $BK\%=%U%H%&%'%"$r!$%i%$%V%i%j7A<0$J$I!$B>$N%=%U%H%&%'%"3+H/$K;H(B
 *      $BMQ$G$-$k7A$G:FG[I[$9$k>l9g$K$O!$:FG[I[$KH<$&%I%-%e%a%s%H!JMxMQ(B
 *      $B<T%^%K%e%"%k$J$I!K$K!$>e5-$NCx:n8"I=<(!$$3$NMxMQ>r7o$*$h$S2<5-(B
 *      $B$NL5J]>Z5,Dj$r7G:\$9$k$3$H!%(B
 *  (3) $BK\%=%U%H%&%'%"$r!$5!4o$KAH$_9~$`$J$I!$B>$N%=%U%H%&%'%"3+H/$K;H(B
 *      $BMQ$G$-$J$$7A$G:FG[I[$9$k>l9g$K$O!$<!$N$$$:$l$+$N>r7o$rK~$?$9$3(B
 *      $B$H!%(B
 *    (a) $B:FG[I[$KH<$&%I%-%e%a%s%H!JMxMQ<T%^%K%e%"%k$J$I!K$K!$>e5-$NCx(B
 *        $B:n8"I=<(!$$3$NMxMQ>r7o$*$h$S2<5-$NL5J]>Z5,Dj$r7G:\$9$k$3$H!%(B
 *    (b) $B:FG[I[$N7ABV$r!$JL$KDj$a$kJ}K!$K$h$C$F!$(BTOPPERS$B%W%m%8%'%/%H$K(B
 *        $BJs9p$9$k$3$H!%(B
 *  (4) $BK\%=%U%H%&%'%"$NMxMQ$K$h$jD>@\E*$^$?$O4V@\E*$K@8$8$k$$$+$J$kB;(B
 *      $B32$+$i$b!$>e5-Cx:n8"<T$*$h$S(BTOPPERS$B%W%m%8%'%/%H$rLH@U$9$k$3$H!%(B
 *      $B$^$?!$K\%=%U%H%&%'%"$N%f!<%6$^$?$O%(%s%I%f!<%6$+$i$N$$$+$J$kM}(B
 *      $BM3$K4p$E$/@A5a$+$i$b!$>e5-Cx:n8"<T$*$h$S(BTOPPERS$B%W%m%8%'%/%H$r(B
 *      $BLH@U$9$k$3$H!%(B
 * 
 *  $BK\%=%U%H%&%'%"$O!$L5J]>Z$GDs6!$5$l$F$$$k$b$N$G$"$k!%>e5-Cx:n8"<T$*(B
 *  $B$h$S(BTOPPERS$B%W%m%8%'%/%H$O!$K\%=%U%H%&%'%"$K4X$7$F!$FCDj$N;HMQL\E*(B
 *  $B$KBP$9$kE,9g@-$b4^$a$F!$$$$+$J$kJ]>Z$b9T$o$J$$!%$^$?!$K\%=%U%H%&%'(B
 *  $B%"$NMxMQ$K$h$jD>@\E*$^$?$O4V@\E*$K@8$8$?$$$+$J$kB;32$K4X$7$F$b!$$=(B
 *  $B$N@UG$$rIi$o$J$$!%(B
 * 
 *  @(#) $Id: $
 */

#ifndef TARGET_SWITCH_H
#define TARGET_SWITCH_H

extern void init_switch(void);
extern void watch_switch(void);

/* $B%9%$%C%A(BON/OFF$B%$%Y%s%HH/@8;~$N%3!<%k%P%C%/(B */
extern void sw1_on(void);
extern void sw1_off(void);
extern void sw2_on(void);
extern void sw2_off(void);

#endif /* TARGET_SWITCH_H */
