/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2007-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006-2008 by Task-intelligence Research Group,
 *             Intelligent Systems Research Institute,
 *             National Institute of
 *               Advanced Industrial Science and Technology (AIST), Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id$
 */

/*
 * ^[QbgˑW[(Armadillo-240)
 */
#include "kernel_impl.h"
#include <sil.h>

#ifdef OPENRTM_CONFIG_MODE
#include "OpenRTMSetup.h"
#endif /* OPENRTM_CONFIG_MODE */

#ifdef INCLUDE_ARMADILLO_PDIC
#include "ethmac.h"
#endif /* INCLUDE_ARMADILLO_PDIC */

/*
 * }bvichipˑĂяoj
 */
void
target_mmu_initialize(void)
{
	MEMORY_ATTRIBUTE mattr;
#ifdef TOPPERS_BOOT_ROM
	/* 0x60000000 ̃}bsO */
	mattr.pa = 0x60000000;
	mattr.va = 0x60000000;
#if (TARGET_ARMADILLO_TYPE == armadillo210)
	mattr.pgsize = PG_SIZE(0x400000);
#elif (TARGET_ARMADILLO_TYPE == armadillo240)
	mattr.pgsize = PG_SIZE(0x800000);
#endif /* TARGET_ARMADILLO_TYPE */
	mattr.ap = RWRW;
	mattr.cb = WRITE_THROW;
	mattr.dom = 0;
	mmu_map_region(&mattr);
#endif
#if (TARGET_ARMADILLO_TYPE == armadillo210)
	/* 0xC0000000 ̃}bsO */
	mattr.pa = 0xC0000000;
	mattr.va = 0xC0000000;
	mattr.pgsize = PG_SIZE(0x0800000);
	mattr.ap = RWRW;
//	mattr.cb = WRITE_THROW;
	mattr.cb = NON_CACH_NON_BUFF;
	mattr.dom = 0;
	mmu_map_region(&mattr);

	mattr.pa = 0xC1000000;
	mattr.va = 0xC0800000;
	mattr.pgsize = PG_SIZE(0x0800000);
	mattr.ap = RWRW;
//	mattr.cb = WRITE_THROW;
	mattr.cb = NON_CACH_NON_BUFF;
	mattr.dom = 0;
	mmu_map_region(&mattr);

	mattr.pa = 0xC4000000;
	mattr.va = 0xC1000000;
	mattr.pgsize = PG_SIZE(0x0800000);
	mattr.ap = RWRW;
//	mattr.cb = WRITE_THROW;
	mattr.cb = NON_CACH_NON_BUFF;
	mattr.dom = 0;
	mmu_map_region(&mattr);

	mattr.pa = 0xC5000000;
	mattr.va = 0xC1800000;
	mattr.pgsize = PG_SIZE(0x0800000);
	mattr.ap = RWRW;
//	mattr.cb = WRITE_THROW;
	mattr.cb = NON_CACH_NON_BUFF;
	mattr.dom = 0;
	mmu_map_region(&mattr);
#elif (TARGET_ARMADILLO_TYPE == armadillo240)
	/* 0xC0000000 ̃}bsO */
	mattr.pa = 0xC0000000;
	mattr.va = 0xC0000000;
	mattr.pgsize = PG_SIZE(0x2000000);
	mattr.ap = RWRW;
//	mattr.cb = WRITE_THROW;
	mattr.cb = NON_CACH_NON_BUFF;
	mattr.dom = 0;
	mmu_map_region(&mattr);

	mattr.pa = 0xC4000000;
	mattr.va = 0xC2000000;
	mattr.pgsize = PG_SIZE(0x2000000);
	mattr.ap = RWRW;
//	mattr.cb = WRITE_THROW;
	mattr.cb = NON_CACH_NON_BUFF;
	mattr.dom = 0;
	mmu_map_region(&mattr);
#endif /* TARGET_ARMADILLO_TYPE */
}

/*
 * ^[Qbgˑ̏
 */
void
target_initialize(void)
{
#ifdef OPENRTM_CONFIG_MODE
	ep93xx_init_uart();
	/*
	 *  VXeRtBO[Vݒ
	 *    JP1V[gĂꍇAݒ胂[hɈڍs
	 */
	if (!(sil_rew_mem((void*)GPIO_PBDR) & CONFIG_MODE_BIT)) {
		OpenRTMSetup();

		/* VXeRtBO[V́Aȍ~͎sȂ */
		chip_exit();
	}
#endif /* OPENRTM_CONFIG_MODE */

#ifdef INCLUDE_ARMADILLO_PDIC
	/*
	 *  IPAhXݒ
	 *    RtBOf[^̈悩ݒ肳ĂIPAhX擾
	 *    TINET̊Ǘ̈ɐݒ肷
	 */
	{
		uint8_t s_addr[21 + 1];
		uint32_t ip_addr;
		uint16_t port;
		if (getConfigContent((uint8_t *)"corba.endpoint", s_addr, 22) &&
			unpack_ip_port(s_addr, &ip_addr, &port)) {
			set_ipaddr(ip_addr);
			set_endp_portno(port);
		}
	}
#endif /* INCLUDE_ARMADILLO_PDIC */

	/*
	 * `bvˑ̏
	 */
	chip_initialize();
}

/*
 * ^[Qbgˑ̏I
 */
void
target_exit(void)
{
	/*
	 * `bvˑ̏I
	 */
	chip_exit();

	while (1) ;
}
