#include <itron.h>
#include <kernel.h>
#include <t_syslog.h>
#include "kernel_cfg.h"
#include "sample1n.h"

#include "tinet_id.h"
#include <tinet_defs.h>
#include <tinet_config.h>
#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/net_buf.h>
#include <netinet/in.h>
#include <netinet/in_itron.h>
#include <netinet/ip.h>
#include <netinet/ip6.h>
#include <netinet/tcp.h>
#include <netinet/tcp_timer.h>
#include <netinet/tcp_var.h>
#include <netinet/tcp_fsm.h>
#include <netinet/udp_var.h>


#define TNUM_TCP_REPID	1

const ID tmax_tcp_repid = (TMIN_TCP_REPID + TNUM_TCP_REPID - 1);

T_TCP4_REP tcp_rep[TNUM_TCP_REPID] = {
	{
#if defined(TCP_CFG_EXTENTIONS)
		TCP_REP_FLG_VALID,
		SEM_TCP_REP_LOCK1,
#endif
		0,
		{ IPV4_ADDRANY, 23 },
		},
	};

#define TNUM_TCP_CEPID	1

const ID tmax_tcp_cepid = (TMIN_TCP_CEPID + TNUM_TCP_CEPID - 1);

T_TCP4_CEP tcp_cep[TNUM_TCP_CEPID] = {
	{
		TCP_CEP_FLG_VALID,
		0,
		(VP)tcp_swbuf,
		TCP_SWBUF_SIZE,
		(VP)tcp_rwbuf,
		TCP_RWBUF_SIZE,
		(FP)( FP ) callback_nblk_tcp,
		SEM_TCP_CEP_LOCK1,
		FLG_TCP_CEP_EST1,
		FLG_TCP_CEP_SND1,
		FLG_TCP_CEP_RCV1,
		},
	};

