/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2007 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2006-2008 by Task-intelligence Research Group,
 *             Intelligent Systems Research Institute,
 *             National Institute of
 *               Advanced Industrial Science and Technology (AIST), Japan
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: if_ed.c,v 1.4 2007/11/09 00:42:31 abe Exp abe $
 */

/*
 * Copyright (c) 1995, David Greenman
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice unmodified, this list of conditions, and the following
 *    disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $FreeBSD: src/sys/i386/isa/if_ed.c,v 1.148.2.4 1999/09/25 13:08:18 nyan Exp $
 */

/*
 * Device driver for National Semiconductor DS8390/WD83C690 based ethernet
 *   adapters. By David Greenman, 29-April-1993
 *
 * Currently supports the Western Digital/SMC 8003 and 8013 series,
 *   the SMC Elite Ultra (8216), the 3Com 3c503, the NE1000 and NE2000,
 *   and a variety of similar clones.
 *
 */

#include <itron.h>
#include <kernel.h>
#include <t_syslog.h>
#include "kernel_cfg.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/ethernet.h>
#include <net/if_arp.h>
#include <net/net.h>
#include <net/net_timer.h>
#include <net/net_count.h>
#include <net/net_buf.h>

#include "if_ep93xxreg.h"
#include "i2c_eeprom.h"

/*------------------------------------------------------------------------
	Definitions
------------------------------------------------------------------------*/
#define DEFAULT_INTSRC		(INTEN_TSQIE | INTEN_RXEOFIE | INTEN_RXEOBIE | \
							 INTEN_RXHDRIE)

#define LVL_TXSTOP			(LEN_QUE_SEND_DESC - 2)
#define LVL_TXRESUME		(2)

#define IDX_NEXT(idx, len)	(((idx) + 1) % (len))

/*
 *  ͥåȥ󥿥ե˰¸륽եȥ 
 */
typedef struct _RxDescriptor {
	uint32_t ba:32,
		bl:16,
		bi:15,
		nsof:1;
} RxDescriptor;

typedef struct _RxStatus {
	uint32_t rsrv1:8,
		hti:6,
		rsrv2:1,
		crci:1,
		crce:1,
		edata:1,
		runt:1,
		fe:1,
		oe:1,
		rxerr:1,
		am:2,
		rsrv3:4,
		eob:1,
		eof:1,
		rwe:1,
		rfp1:1,
		fl:16,
		bi:15,
		rfp2:1;
} RxStatus;
typedef struct _TxDescriptor {
	uint32_t ba:32,
		bl:12,
		resv1:3,
		af:1,
		bi:15,
		eof:1;
} TxDescriptor;
typedef struct _TxStatus {
	uint32_t bi:15,
		rsrv1:1,
		ncoll:5,
		rsrv2:3,
		ecoll:1,
		txu:1,
		ow:1,
		rsrv3:1,
		lcrs:1,
		fa:1,
		txwe:1,
		txfp:1;
} TxStatus;

typedef struct t_ep93xx_softc {
#if 1
	RxDescriptor que_rx_desc[LEN_QUE_RECV_DESC];
	RxStatus que_rx_sts[LEN_QUE_RECV_STS];
	TxDescriptor que_tx_desc[LEN_QUE_SEND_DESC];
	TxStatus que_tx_sts[LEN_QUE_SEND_STS];

	int_t idx_que_rx_desc;
	int_t idx_que_rx_sts;
	int_t idx_que_tx_desc;
	int_t idx_que_tx_sts;
#else
	uint32_t	nic_addr;			/* NIC Υ١ɥ쥹	*/
	uint32_t	asic_addr;			/* ASIC Υ١ɥ쥹*/
	uint16_t	txb_len[NUM_IF_EP93XX_TXBUF];	/* ХåեΥƥåȿ*/
	uint8_t		txb_inuse;			/* Хåե	*/
	uint8_t		txb_insend;			/* Хåե	*/
	uint8_t		txb_write;			/* 񤭹Хåե	*/
	uint8_t		txb_send;			/* Хåե	*/
	uint8_t		rxb_read;			/* ɤ߹ڡ	*/
#endif
} T_EP93XX_SOFTC;

#define MII_ID_PHY		(1)

/*------------------------------------------------------------------------
	Private Variables
------------------------------------------------------------------------*/
/*
 *  ͥåȥ󥿥եΥեȥ
 */
T_IF_ETHER_NIC_SOFTC ep93xx_softc;

/* ͥåȥ󥿥ե˰¸ʤեȥ */
T_IF_SOFTC if_softc = {
	{ {0, 0, 0, 0, 0, 0} },		/* ͥåȥ󥿥եΥɥ쥹	*/
	0,							/* ॢ			*/
	&ep93xx_softc,				/* ǥХ¸Υեȥ	*/
	SEM_IF_EP93XX_SBUF_READY,	/* ޥե			*/
	SEM_IF_EP93XX_RBUF_READY,	/* ޥե			*/

#ifdef SUPPORT_INET6

	IF_MADDR_INIT,				/* ޥ㥹ȥɥ쥹ꥹ	*/

#endif	/* of #ifdef SUPPORT_INET6 */
};

static uint8_t rx_buf[LEN_QUE_RECV_DESC][LEN_RXBUF];
static uint8_t tx_buf[LEN_QUE_SEND_DESC][LEN_TXBUF];

static int_t g_phy_autonego_done = 0;


/*------------------------------------------------------------------------
	Private Functions
------------------------------------------------------------------------*/
static int_t wait_mac_sts(uint32_t reg, uint32_t mask, uint32_t expect, bool_t tout)
{
	int_t i;
	int_t dt;

	for (i = 0; i < 10000; ) {
		dt = sil_rew_mem((void*)reg);
		dt = (dt ^ expect) & mask;
		if (dt == 0) {
			break;
		}
		if (tout) {
			i++;
		}
	}

	return dt;
}

/*
 * PHY󥿡ե
 */
#define phy_wait_rdy()		wait_mac_sts(MAC_MIISTS, MIISTS_BUSY, ~MIISTS_BUSY, true)

static void phy_write(int_t id_phy, int_t reg, uint16_t dt)
{
	uint32_t oldval;

	oldval = sil_rew_mem((void*)MAC_SELFCTL);
	sil_wrw_mem((void*)MAC_SELFCTL, oldval & ~SELFCTL_PSPRS);

	phy_wait_rdy();
	sil_wrw_mem((void*)MAC_MIIDATA, dt);
	sil_wrw_mem((void*)MAC_MIICMD, MIICMD_OP_WR | ((id_phy & 0x1F) << 5) | (reg & 0x1F));

	sil_wrw_mem((void*)MAC_SELFCTL, oldval);
}

static uint16_t phy_read(int_t id_phy, int_t reg)
{
	uint32_t oldval;
	uint16_t dt;

	oldval = sil_rew_mem((void*)MAC_SELFCTL);
	sil_wrw_mem((void*)MAC_SELFCTL, oldval & ~SELFCTL_PSPRS);

	phy_wait_rdy();
	sil_wrw_mem((void*)MAC_MIICMD, MIICMD_OP_RE | (id_phy & 0x1F) << 5 | (reg & 0x1F));
	phy_wait_rdy();
	dt = sil_rew_mem((void*)MAC_MIIDATA);

	sil_wrw_mem((void*)MAC_SELFCTL, oldval);

	return dt;
}

static int_t phy_auto_negotiation(void)
{
	uint16_t val;
	int_t retry;

	phy_write(MII_ID_PHY, 4, 0x01E1);
	phy_write(MII_ID_PHY, 0, (1 << 12) | (1 << 9));

	retry = 0;
	while (1) {
		val = phy_read(MII_ID_PHY, 1);
		if (val & 0x0020) {
			break;
		} else {
			if (retry >= 3) {
				return -1;
			}
			dly_tsk(1000);
			retry++;
		}
	}

	dly_tsk(1000);

	val = phy_read(MII_ID_PHY, 5);
	if (val & 0x0004) {
		sil_orw((void*)MAC_TESTCTL, TESTCTL_MFDX);
	}
	g_phy_autonego_done = 1;

	return 0;
}

static int_t phy_init(void)
{
	uint16_t val;

	val = phy_read(MII_ID_PHY, 1);
	if (val & 0x0004) {
		return phy_auto_negotiation();
	}

	return 0;
}

/*
 * Queue󥿡ե
 */
static void devque_init(T_IF_SOFTC *ic)
{
	uint32_t len;
	int_t i;
	T_IF_ETHER_NIC_SOFTC *sc = ic->sc;

	sil_orw((void*)MAC_BMCTL, BMCTL_TXDIS | BMCTL_RXDIS);
	wait_mac_sts(MAC_BMSTS, BMSTS_TXACT, ~BMSTS_TXACT, true);
	wait_mac_sts(MAC_BMSTS, BMSTS_RXACT, ~BMSTS_RXACT, true);

	/* Tx Status */
	len = sizeof(TxStatus) * LEN_QUE_SEND_STS;
	memset(sc->que_tx_sts, 0, len);
	sc->idx_que_tx_sts = 0;
	sil_wrw_mem((void*)MAC_TXSTSQ_BADD, (uint32_t)sc->que_tx_sts);
	sil_wrw_mem((void*)MAC_TXSTSQ_CURADD, (uint32_t)sc->que_tx_sts);
	sil_wrw_mem((void*)MAC_TXSTSQ_BLEN, len);
	sil_wrh_mem((void*)MAC_TXSTSQ_CURLEN, len);

	/* Tx Descriptor */
	len = sizeof(TxDescriptor) * LEN_QUE_SEND_DESC;
	memset(sc->que_tx_desc, 0, len);
	sc->idx_que_tx_desc = 0;
	sil_wrw_mem((void*)MAC_TXDQ_BADD, (uint32_t)sc->que_tx_desc);
	sil_wrw_mem((void*)MAC_TXDQ_CURADD, (uint32_t)sc->que_tx_desc);
	sil_wrw_mem((void*)MAC_TXDQ_BLEN, len);
	sil_wrh_mem((void*)MAC_TXDQ_CURLEN, len);

	/* Rx Status */
	len = sizeof(RxStatus) * LEN_QUE_RECV_STS;
	memset(sc->que_rx_sts, 0, len);
	sc->idx_que_rx_sts = 0;
	sil_wrw_mem((void*)MAC_RXSTSQ_BADD, (uint32_t)sc->que_rx_sts);
	sil_wrw_mem((void*)MAC_RXSTSQ_CURADD, (uint32_t)sc->que_rx_sts);
	sil_wrw_mem((void*)MAC_RXSTSQ_BLEN, len);
	sil_wrh_mem((void*)MAC_RXSTSQ_CURLEN, len);

	/* Rx Descriptor */
	len = sizeof(RxDescriptor) * LEN_QUE_RECV_DESC;
	for (i = 0; i < LEN_QUE_RECV_DESC; i++) {
		sc->que_rx_desc[i].bi = i;
		sc->que_rx_desc[i].ba = (uint32_t)(rx_buf[i]);
		sc->que_rx_desc[i].bl = LEN_RXBUF;
	}
	sc->idx_que_rx_desc = 0;
	sil_wrw_mem((void*)MAC_RXDQ_BADD, (uint32_t)sc->que_rx_desc);
	sil_wrw_mem((void*)MAC_RXDQ_CURADD, (uint32_t)sc->que_rx_desc);
	sil_wrw_mem((void*)MAC_RXDQ_BLEN, len);
	sil_wrh_mem((void*)MAC_RXDQ_CURLEN, len);

	sil_orw((void*)MAC_BMCTL, BMCTL_TXEN | BMCTL_RXEN);
	wait_mac_sts(MAC_BMSTS, BMSTS_TXACT | BMSTS_RXACT, BMSTS_TXACT | BMSTS_RXACT, true);

	sil_wrw_mem((void*)MAC_RXSTSENQ, LEN_QUE_RECV_STS);
	sil_wrw_mem((void*)MAC_RXDENQ, LEN_QUE_RECV_DESC);
}

static void eth_rxctl(int_t sw)
{
	uint32_t val;

	val = sil_rew_mem((void*)MAC_RXCTL);

	if (sw) {
		val |= (RXCTL_SRXON | RXCTL_RCRCA);
	} else {
		val &= ~RXCTL_SRXON;
	}

	sil_wrw_mem((void*)MAC_RXCTL, val);
}

static void eth_enable(void)
{
	sil_wrw_mem((void*)MAC_INTEN, DEFAULT_INTSRC);
	sil_wrw_mem((void*)MAC_GLINTMSK, GLINTMSK_INT);

	eth_rxctl(1);
}

/*
 * Ethernetɥ쥹
 */
static void eth_ind_addr_write(int_t afp, char_t*  buf)
{
	uint32_t val;
	int_t len, i;

	len = (afp == AFP_AFP_HASH) ? 8 : 6;

	/* ̵ˤ */
	val = sil_rew_mem((void*)MAC_RXCTL);
	sil_wrw_mem((void*)MAC_RXCTL, val & ~RXCTL_SRXON);

	sil_wrw_mem((void*)MAC_AFP, afp);
	for (i = 0; i < len; i++) {
		sil_wrb_mem((void*)(MAC_INDAD + i), buf[i]);
	}
	/* κͭˤ */
	sil_wrw_mem((void*)MAC_RXCTL, val);
}

/*
 * eth_reset -- ͥåȥ󥿥եꥻåȤ롣
 */
static void eth_reset(T_IF_SOFTC *ic)
{
	uint32_t val;
	int_t i;

	NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_RESETS], 1);

	sil_wrb_mem((void*)MAC_SELFCTL, SELFCTL_RESET);
	while ((sil_rew_mem((void*)MAC_SELFCTL) & SELFCTL_RESET) != 0) ;

	val = sil_rew_mem((void*)MAC_SELFCTL);
	val &= ~0x7F00;
	sil_wrw_mem((void*)MAC_SELFCTL, val | 0x2900);

	/* 󥯥åԤ */
	for (i = 0; i < 10; i++) {
		val = phy_read(MII_ID_PHY, 1);
		if (val & 0x0004) {
			break;
		}
		dly_tsk(50);
	}
}

/*
 * eth_init -- ͥåȥ󥿥ե롣
 */
static void eth_init(T_IF_SOFTC *ic)
{
	int_t status;

	g_phy_autonego_done = 0;
	status = phy_init();
	if (status != 0) {
		syslog(LOG_WARNING, "Link is down!");
	}

	/* 쥸ꥻå */
	sil_wrw_mem((void*)MAC_GLINTMSK, 0x00);
	sil_wrw_mem((void*)MAC_RXCTL, RXCTL_BA | RXCTL_IA0);
	sil_wrw_mem((void*)MAC_TXCTL, 0x00);
	sil_wrw_mem((void*)MAC_GT, 0x00);
	sil_wrw_mem((void*)MAC_BMCTL, 0x00);
	sil_wrw_mem((void*)MAC_RXBUF_THRSHLD, (0x80 << 16) | (0x40));
	sil_wrw_mem((void*)MAC_TXBUF_THRSHLD, (0x80 << 16) | (0x40));
	sil_wrw_mem((void*)MAC_RXSTS_THRSHLD, (0x01 << 18) | (0x00 << 2));
	sil_wrw_mem((void*)MAC_TXSTS_THRSHLD, (0x01 << 18) | (0x00 << 2));
	sil_wrw_mem((void*)MAC_RXD_THRSHLD, (0x01 << 18) | (0x00 << 2));
	sil_wrw_mem((void*)MAC_TXD_THRSHLD, (0x01 << 18) | (0x00 << 2));
	sil_wrw_mem((void*)MAC_MAXFRMLEN, ((1518 + 1) << 16) | (944));

	sil_rew_mem((void*)MAC_TXCOLLCNT);
	sil_rew_mem((void*)MAC_RXMISSCNT);
	sil_rew_mem((void*)MAC_RXRUNTCNT);
	sil_rew_mem((void*)MAC_INTSTSC);

	sil_orw((void*)MAC_TXCTL, TXCTL_STXON);

	eth_ind_addr_write(AFP_AFP_IA0, ic->ifaddr.lladdr);

	devque_init(ic);

	eth_enable();
}

static T_NET_BUF* eth_get_frame(T_IF_ETHER_NIC_SOFTC *sc, int_t idx, uint16_t len)
{
	T_NET_BUF *input = NULL;
	uint16_t align;
	uint8_t *dst;
	ER error;

	align = ((((len - sizeof(T_IF_HDR)) + 3) >> 2) << 2) + sizeof(T_IF_HDR);
	error = tget_net_buf(&input, align, TMO_IF_EP93XX_GET_NET_BUF);
	if (error == E_OK && input != NULL) {
		NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_IN_PACKETS], 1);
		NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_IN_OCTETS], len);

		dst = input->buf + IF_ETHER_NIC_HDR_ALIGN;
		memcpy(dst, sc->que_rx_desc[idx].ba, len);
	} else {
		NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_IN_ERR_PACKETS], 1);
		NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_NO_BUFS], 1);
	}

	return input;
}

static void eth_isr_rx(T_IF_SOFTC *ic)
{
	if (isig_sem(ic->semid_rxb_ready) != E_OK) {
		NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_RXB_QOVRS], 1);
	}
}

static void eth_isr_tx(T_IF_SOFTC *ic)
{
	T_IF_ETHER_NIC_SOFTC *sc = ic->sc;
	TxStatus* tx_sts;
	int_t idx_sts;
	int_t num_tx_enq;

	while (sc->que_tx_sts[sc->idx_que_tx_sts].txfp) {
		idx_sts = sc->idx_que_tx_sts;
		sc->idx_que_tx_sts = IDX_NEXT(sc->idx_que_tx_sts, LEN_QUE_SEND_STS);
		tx_sts = &sc->que_tx_sts[idx_sts];
		tx_sts->txfp = 0;


		/* ॢȤΥꥻå */
		ic->timer = 0;

		if (isig_sem(ic->semid_txb_ready) != E_OK) {
			NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_TXB_QOVRS], 1);
		}

		if (tx_sts->txwe) {
			/*  */
		} else {
			/* 顼 */
			NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_OUT_ERR_PACKETS], 1);
			if (tx_sts->lcrs) {
				/* CRC */
			}
			if (tx_sts->txu) {
				/* 쥤ƥ󥷡­ʤ */
			}
			if (tx_sts->ecoll) {
				/* ꥸ󥨥顼 */
				NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_COLS], 1);
			}
		}

		num_tx_enq = sc->idx_que_tx_desc - sc->idx_que_tx_sts;
		if (num_tx_enq < 0) {
			num_tx_enq += LEN_QUE_SEND_DESC;
		}
		if (num_tx_enq > 0) {
			/* Ԥ */
			sil_wrw_mem((void*)MAC_TXDENQ, 1);
			ic->timer = TMO_IF_EP93XX_XMIT;
		}
	}
}

/*------------------------------------------------------------------------
	Public Functions
------------------------------------------------------------------------*/
/*
 *  ep93xx_get_softc -- ͥåȥ󥿥եΥեȥ֤
 */
T_IF_SOFTC * ep93xx_get_softc(void)
{
	return &if_softc;
}

/*
 * ep93xx_watchdog -- ͥåȥ󥿥եΥåɥåॢ
 */
void ep93xx_watchdog(T_IF_SOFTC *ic)
{
	NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_OUT_ERR_PACKETS], 1);
	NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_TIMEOUTS], 1);

	mac_disable_int();

	eth_reset(ic);
	eth_init(ic);

	mac_enable_int();
}

/*
 * ep93xx_probe -- ͥåȥ󥿥եθ
 */
void ep93xx_probe(T_IF_SOFTC *ic)
{
	eth_reset(ic);

	/* MACɥ쥹ɹ */
	GET_MAC_ADDR(ic->ifaddr.lladdr);
}

/*
 * ep93xx_init -- ͥåȥ󥿥եν
 */
void ep93xx_init(T_IF_SOFTC *ic)
{
	mac_disable_int();

	eth_init(ic);

	mac_enable_int();
}

/*
 * ep93xx_read -- ե졼ɤ߹
 */
T_NET_BUF* ep93xx_read(T_IF_SOFTC *ic)
{
	T_NET_BUF* input = NULL;
	T_IF_ETHER_NIC_SOFTC *sc = ic->sc;
	uint32_t val;
	RxStatus *qrx_sts;
	int_t idx_qrx_sts_head;
	int_t idx_sts;
	int_t cnt_sts;
	int_t cnt_desc;

	mac_disable_int();

	val = sil_rew_mem((void*)MAC_RXSTSQ_CURADD);
	idx_qrx_sts_head = (val - (uint32_t)sc->que_rx_sts) / sizeof(sc->que_rx_sts[0]);
	if (idx_qrx_sts_head < 0 || idx_qrx_sts_head >= LEN_QUE_RECV_STS) {
		/* ̵ʥǥå */
		mac_enable_int();
		return NULL;
	}

	cnt_sts = cnt_desc = 0;
	while (idx_qrx_sts_head != sc->idx_que_rx_sts && input == NULL) {
		idx_sts = sc->idx_que_rx_sts;
		sc->idx_que_rx_sts = IDX_NEXT(sc->idx_que_rx_sts, LEN_QUE_RECV_STS);
		qrx_sts = &sc->que_rx_sts[idx_sts];
		if (!qrx_sts->rfp1) {
			/* Queue */
			mac_enable_int();
			return NULL;
		}
		qrx_sts->rfp1 = 0;
		qrx_sts->rfp2 = 0;

		if (qrx_sts->eob) {
			if (qrx_sts->bi == sc->idx_que_rx_desc) {
				sc->idx_que_rx_desc = IDX_NEXT(sc->idx_que_rx_desc, LEN_QUE_RECV_DESC);
				cnt_desc++;
				if (qrx_sts->eof && qrx_sts->rwe) {
					input = eth_get_frame(sc, qrx_sts->bi, qrx_sts->fl);
				} else {
					/* 顼 */
					NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_IN_ERR_PACKETS], 1);
#if 0
					if (qrx_sts->oe) {
						/* С󥨥顼 */
					}
					if (qrx_sts->fe) {
						/* ե졼ߥ󥰥顼 */
					}
					if (qrx_sts->runt || qrx_sts->edata) {
						/* ǡĹ顼 */
					}
					if (qrx_sts->crce) {
						/* CRC顼 */
					}
#endif
				}
			} else {
				/* ǥå԰ */
				;
			}
		}
		cnt_sts++;
	}

	sil_wrw_mem((void*)MAC_RXSTSENQ, cnt_sts);
	sil_wrw_mem((void*)MAC_RXDENQ, cnt_desc);

	/* ǡޤ¸ߤƤ顢׵᤹ */
	if (idx_qrx_sts_head != sc->idx_que_rx_sts) {
		if (sig_sem(ic->semid_rxb_ready) != E_OK) {
			NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_RXB_QOVRS], 1);
		}
	}

	mac_enable_int();

	return input;
}

/*
 * ep93xx_start -- ե졼Хåե󥰤롣
 */
void ep93xx_start(T_IF_SOFTC *ic, T_NET_BUF *output)
{
	T_IF_ETHER_NIC_SOFTC *sc = ic->sc;
	TxDescriptor *tx_desc;
	int_t idx_qtx_desc;
	int_t txlen;
	int_t status;
	int_t num_tx_enq;

	NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_OUT_PACKETS], 1);
	NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_OUT_OCTETS], output->len);

	mac_disable_int();

	/* MII󥿡ե̤ξ硢 */
	if (g_phy_autonego_done == 0) {
		status = phy_init();
		if (status != 0) {
			mac_enable_int();
			return;
		}
	}

	/* ǥץΥǥåȥХåեμ */
	idx_qtx_desc = sc->idx_que_tx_desc;
	tx_desc = &sc->que_tx_desc[idx_qtx_desc];

//	syslog(LOG_NOTICE, "[send packet] len:%d txid:%d", output->len, idx_qtx_desc);

	/* ǡĹ
	 * 60ХȰʲξϡ60ХȤ	 */
	if (output->len < ETHER_MIN_LEN - ETHER_CRC_LEN) {
		memset(tx_buf[idx_qtx_desc], 0, ETHER_MIN_LEN - ETHER_CRC_LEN);
		txlen = ETHER_MIN_LEN - ETHER_CRC_LEN;
	} else {
		txlen = output->len;
	}

	if (txlen > LEN_TXBUF) {
		/* ǡĹ顼 */
		mac_enable_int();
		return;
	}
	/* ǥץ */
	sc->que_tx_desc[idx_qtx_desc].bl = txlen;
	sc->que_tx_desc[idx_qtx_desc].ba = (uint32_t)tx_buf[idx_qtx_desc];
	sc->que_tx_desc[idx_qtx_desc].bi = idx_qtx_desc;
	sc->que_tx_desc[idx_qtx_desc].af = 0;
	sc->que_tx_desc[idx_qtx_desc].eof = 1;

	/* ǡХåե˥ԡ */
	memcpy(tx_buf[idx_qtx_desc], output->buf + IF_ETHER_NIC_HDR_ALIGN, output->len);
	/* ơν˥ȥ餬ơꤹ */
	memset(&sc->que_tx_sts[idx_qtx_desc], 0, sizeof(TxStatus));

	/* ǥץΥ󥯥 */
	sc->idx_que_tx_desc = IDX_NEXT(sc->idx_que_tx_desc, LEN_QUE_SEND_DESC);

	num_tx_enq = idx_qtx_desc - sc->idx_que_tx_sts;
	if (num_tx_enq == 0) {
//		syslog(LOG_NOTICE, "[send enque] desc:%d sts:%d", idx_qtx_desc, sc->idx_que_tx_sts);
		sil_wrw_mem((void*)MAC_TXDENQ, 1);

		/* ॢȤ */
		ic->timer = TMO_IF_EP93XX_XMIT;
	}

	mac_enable_int();
}

/*
 * ep93xx_reset -- ͥåȥ󥿥եꥻåȤ롣
 */

void ep93xx_reset (T_IF_SOFTC *ic)
{
	mac_disable_int();

	NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_RESETS], 1);

	eth_init(ic);

	mac_enable_int();
}

/*
 *  NIC ߥϥɥ
 */
void if_ep93xx_handler(void)
{
	uint32_t sts;

	sts = sil_rew_mem((void*)MAC_INTSTSC);
	if (sts & INTSTS_RXSQ) {
		eth_isr_rx(&if_softc);
	}
	if (sts & INTSTS_TXSQ) {
		eth_isr_tx(&if_softc);
	}
}
